<?php
session_start();
include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once LIBSDIR .'/helpers.php';
require_once LIBSDIR .'/icons.php';
require_once SERVERDIR .'/auth.php';

requireLogIn();
?>

<!DOCTYPE html>
 <html>
    <!-- BEIGN HEAD -->
    <?php view('header', ['title' => 'Add Admin']) ?>
    <!-- END HEAD -->
   <body>
    
     <!--  BEGIN NAVBAR  -->
     <?php view('navbar'); ?>
     <!--  END NAVBAR  -->

     <!--  BEGIN SUBNAVBAR  -->
     <?php view('subnavbar', ['title' => 'Add Admin']) ?>
     <!--  END SUBNAVBAR  -->
     <div class="main-container" id="container">
    
      <!--  BEGIN SIDEBAR  -->
      <?php view('sidebar') ?>
      <!--  END SIDEBAR  -->
     
       <div id="content" class="main-content">
        <div class="layout-px-spacing">
              <!-- Start Content -->
              <div class="row layout-top-spacing">
                <div class="col-xl-12 col-lg-12 col-md-12 col-12 layout-spacing">
                    <div class="row ml-1 mb-2">
                    <a href="manage_admin.php" class="btn_back">
                        <h4 class="pull-left" style="font-size: 20px;color: #06bd8c">
                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-left">
                            <line x1="19" y1="12" x2="5" y2="12"></line>
                            <polyline points="12 19 5 12 12 5"></polyline>
                        </svg> Back
                        </h4>
                    </a>
                    </div>
                    <div class="widget-content widget-content-area br-6">
                    <h3 class="">Add Admin</h3>
                    <div style="border-bottom: 1px solid #f1f2f3; margin-top: 20px; margin-bottom: 20px;"></div>

                    
                    <div id="alert"></div>

                    <form action="server/signup.db.php" name="addedituser" method="post" class="form form-horizontal" enctype="multipart/form-data" id="add-user-form">
                        <div class="row">
                        <div class="col-md-11">
                            <div class="platform-div">                           

                            <div class="form-group row mb-4">
                                <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label">Permission :-</label>
                                <div class="col-xl-10 col-lg-9 col-sm-10">
                                <select name="level" id="level" class="form-control col-md-7 ">
                                    <option value="editor">Editor</option>
                                    <option value="admin">Admin</option>
                                </select>
                                </div>
                            </div>

                            <div class="form-group row mb-4">
                              <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label">Full name :-</label>
                              <div class="col-xl-6 col-lg-9 col-sm-10">
                              <div id="name-field" class="field-wrapper input">
                                 
                                <div class="input-group">
                                <div class="input-group-prepend">
                                <span class="input-group-text"><?php echo editIcon2(); ?></span>
                                </div>
                                <input type="text" class="form-control" name="full_name" placeholder="Ex: Steph">
                                    <div class="invalid-tooltip">
                                     Please enter a unique and valid name.
                                    </div>
                                 </div>

                               </div>
                              </div>
                            </div>
                            

                            <div class="form-group row mb-4">
                              <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label">Username :-</label>
                              <div class="col-xl-6 col-lg-9 col-sm-10">
                              <div id="username-field" class="field-wrapper input">
                                 
                                <!-- <input type="text" name="username" value="" placeholder="Ex: Steph" class="form-control col-md-7"> -->

                                <div class="input-group">
                                <div class="input-group-prepend">
                                <span class="input-group-text"><?php echo userIcon(); ?></span>
                                </div>
                                <input type="text" class="form-control" name="username" placeholder="Ex: stephuser1" required="">
                                    <div class="invalid-tooltip">
                                     Please choose a unique and valid username.
                                    </div>
                                 </div>

                               </div>
                              </div>
                            </div>

                            <div class="form-group row mb-4">
                              <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label">Email :-</label>
                              <div class="col-xl-6 col-lg-9 col-sm-10">
                              <div id="email-field" class="field-wrapper input">
                                 
                                <div class="input-group">
                                <div class="input-group-prepend">
                                <span class="input-group-text"><?= atSignIcon(); ?></span>
                                </div>
                                <input type="email" class="form-control" name="email" placeholder="Ex: steph@mail.com" required="">
                                    <div class="invalid-tooltip">
                                     Please choose a valid email.
                                    </div>
                                 </div>

                               </div>
                              </div>
                            </div>


                            <div class="form-group row mb-4">
                              <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label">Password :-</label>
                              <div class="col-xl-6 col-lg-9 col-sm-10">
                              <div id="password-field" class="field-wrapper input">
                                 
                                <!-- <input type="text" name="username" value="" placeholder="Ex: Steph" class="form-control col-md-7"> -->

                                <div class="input-group">
                                  <div class="input-group-prepend"><span class="input-group-text"><?= lockIcon(); ?></span></div>
                                    <input type="password" id="password" name="password" class="form-control form-password" required="true">
                                    <div class="invalid-tooltip">
                                     Please choose a unique and valid password.
                                    </div>
                                    
                                      <div class="input-group-append">
                                        <span class="input-group-text" id="btnPasswordShowHide">
                                            <div id="show_eye">
                                                <?= eyeIcon(); ?>
                                            </div>
                                            <div class="d-none" id="hide_eye">
                                                <?= eyeOffIcon(); ?>
                                            </div>
                                        </span>
                                      </div>
                                 </div>

                               </div>
                              </div>
                            </div>

                            <div class="form-group row mb-4">
                              <label class="col-xl-2 col-sm-3 col-sm-2 col-form-label"></label>
                              <div class="col-xl-6 col-lg-9 col-sm-10">
                              <div id="btn-field" class="field-wrapper input">
                                 
                                <!-- <input type="text" name="username" value="" placeholder="Ex: Steph" class="form-control col-md-7"> -->

                                <div class="input-group">
                                 <button type="submit" name="submit" id="btnAddUserSubmit" class="btn btn-primary mt-2">Add</button>
                                
                                </div>


                               </div>
                              </div>
                            </div>

                            </div>
                        </div>
                        </div>
                    </form>
                    </div>
                </div>
                </div>
              <!-- End Content -->         
        </div>
        <!--  BEIGN FOOTER -->
        <?php view('footer'); ?>
        <!--  END FOOTER -->
       </div>
      
     </div>
     <!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
     <?php view('globalscript'); ?>
     <!-- END GLOBAL MANDATORY SCRIPTS -->

     <script>
       $(document).ready(function() {
         App.init();
         Users.addUser();
       });
     </script>
   </body>
 </html>