<?php
session_start();
include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once LIBSDIR .'/helpers.php';
require_once LIBSDIR .'/icons.php';
require_once SERVERDIR .'/auth.php';

requireLogIn();

$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
$path = $protocol.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);

function generate_tokens(): array
{
    $selector = bin2hex(random_bytes(16));
    $validator = bin2hex(random_bytes(32));

    return [$selector . ':' . $validator];
}

function parse_token(string $token): ?array
{
    $parts = explode(':', $token);

    if ($parts && count($parts) == 2) {
        return [$parts[0], $parts[1]];
    }
    return null;
}

?>

<!DOCTYPE html>
 <html>
    <!-- BEIGN HEAD -->
    <?php view('header', ['title' => 'API URLS']) ?>
    <!-- END HEAD -->
   <body>
    
     <!--  BEGIN NAVBAR  -->
     <?php view('navbar') ?>
     <!--  END NAVBAR  -->

     <!--  BEGIN SUBNAVBAR  -->
     <?php view('subnavbar', ['title' => 'API URLS']) ?>
     <!--  END SUBNAVBAR  -->
     <div class="main-container" id="container">
    
       <!--  BEGIN SIDEBAR  -->
       <?php view('sidebar') ?>
       <!--  END SIDEBAR  -->
     
       <div id="content" class="main-content">
         <div class="layout-px-spacing">
              <!-- Start Content -->
              <div class="row layout-top-spacing">
                <div class="col-xl-12 col-lg-12 col-md-12 col-12 layout-spacing">
                    <div class="widget-content widget-content-area br-6">
                    <h3 class="">API URL</h3>
                    <?php 
                    
                    $token;
                    foreach(generate_tokens() as $token) {
                         $token;
                    }

                    foreach(parse_token($token) as $value) {
                        echo $value . '<br>';
                    }
                    
                    ?>
                    <div style="border-bottom: 1px solid #f1f2f3; margin-top: 20px; margin-bottom: 20px;"></div>
                    <form>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="clipboard copy-txt">
                                <p class="mb-4">Link -&gt; <span id="advanced-paragraph"><?php echo $path . "/server/api/"; ?></span>
                                </p>
                                <a class="mb-1 btn btn-primary" href="javascript:;" data-clipboard-action="copy" data-clipboard-target="#advanced-paragraph">
                                    <?= copyIcon() ?> Copy API URL </a>
                                <br>
                                </div>
                            </div>

                            <div class="col-md-12">
                                <div class="clipboard copy-txt">
                                  <p class="mb-4">Token -&gt; <span id="advanced-paragraph"><?php echo "Tokenhghgfgfgh"; ?></span>
                                  </p>
                                <div class="row token" style="margin-left:1px;">
                                  <a class="mb-1 btn btn-primary" href="javascript:;" data-clipboard-action="copy" data-clipboard-target="#advanced-paragraph">
                                    <?= copyIcon() ?>  Copy Token </a>
                                  <br>

                                  <a class="mb-1 btn btn-primary" href="javascript:;" data-clipboard-action="copy" data-clipboard-target="#advanced-paragraph">
                                    <?= refreshIcon() ?>  Generate Token </a>
                                  <br>
                                </div>
                                </div>
                            </div>

                        </div>
                    </form>
                    </div>
                    
                </div>
                </div>
              <!-- End Content -->         
          </div>
        <!--  BEIGN FOOTER -->
        <?php view('footer'); ?>
        <!--  END FOOTER -->
       </div>
      
     </div>
     <!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
     <?php view('globalscript') ?>
     <!-- END GLOBAL MANDATORY SCRIPTS -->
   </body>
 </html>