$(document).ready(function () {
    App.init();

    //adsSettings();

    // Add active nav class based on url
    // Get the last item in the path (e.g. index.php)
    let url = window.location.pathname.split('/').pop();
    $("#sidebar ul li a").each(function () {
        if ($(this).attr("href") == url || $(this).attr("href") == '') {
            // $(this).closest('li').addClass("active");
            $(this).attr("data-active", "true");
        }
    })

    $("#btnPasswordShowHide").on('click', function() {
        var x = document.getElementById("password");
        var show_eye = document.getElementById("show_eye");
        var hide_eye = document.getElementById("hide_eye");
        hide_eye.classList.remove("d-none");
        if (x.type === "password") {
        x.type = "text";
         show_eye.style.display = "none";
         hide_eye.style.display = "block";
        } else {
        x.type = "password";
        show_eye.style.display = "block";
        hide_eye.style.display = "none";
        }
    })
});

function isValidHttpUrl(string) {
    let url;
    try {
        url = new URL(string);
    } catch (_) {
        return false;
    }

    return url.protocol === "http:" || url.protocol === "https:";
}

function fileValidation() {
    var fileInput = document.getElementById('fileupload');
    var filePath = fileInput.value;
    var allowedExtensions = /(\.png|.jpg|.jpeg|.PNG|.JPG|.JPEG)$/i;
    if (!allowedExtensions.exec(filePath)) {
        if (filePath != '') swal({
            type: 'error',
            title: 'Please upload file having extension',
            text: '.png, .jpg, .jpeg .PNG, .JPG, .JPEG only.',
            footer: ' < a href > Why do I have this issue ? < /a>',
            padding: '2em'
        }).then(function (result) {
            fileInput.value = '';
        });
        return false;
    } else {
        if (fileInput.files && fileInput.files[0]) {
            var reader = new FileReader();
            reader.onload = function (e) {
                document.getElementById('imagePreview').innerHTML = '< img src ="' + e.target.result + '"'
                style = 'width:auto; height:250px; max-width: 500px;" /> ';
            };
            reader.readAsDataURL(fileInput.files[0]);
        }
    }
}


function adsSettings() {
    // Bannerbanner
    if ($("select[name='banner_ad_type']").val() === 'facebook') {
        $(".banner_size_fb").show();
        $(".banner_facebook_id").show();
        $(".banner_ad_id").hide();
        $(".banner_size").hide();
        $(".banner_startapp_id").hide();
        $(".banner_size_add").show();
        $(".p_ad_id").show();
        $(".p_app_id").hide();
        $(".p_game_id").hide();
        $(".banner_unity_id").hide();
        $(".banner_size_iron").hide();
        $(".p_app_key").hide();
        $(".banner_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'admob') {
        $(".banner_size_fb").hide();
        $(".banner_facebook_id").hide();
        $(".banner_ad_id").show();
        $(".banner_size").show();
        $(".banner_startapp_id").hide();
        $(".banner_size_add").show();
        $(".p_ad_id").show();
        $(".p_app_id").hide();
        $(".p_game_id").hide();
        $(".banner_unity_id").hide();
        $(".banner_size_iron").hide();
        $(".p_app_key").hide();
        $(".banner_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'startapp') {
        $(".banner_size_fb").hide();
        $(".banner_facebook_id").hide();
        $(".banner_ad_id").hide();
        $(".banner_size").hide();
        $(".banner_startapp_id").show();
        $(".banner_size_add").hide();
        $(".p_ad_id").hide();
        $(".p_app_id").show();
        $(".p_game_id").hide();
        $(".banner_unity_id").hide();
        $(".banner_size_iron").hide();
        $(".p_app_key").hide();
        $(".banner_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'unity') {
        $(".banner_size_fb").hide();
        $(".banner_facebook_id").hide();
        $(".banner_ad_id").hide();
        $(".banner_size").hide();
        $(".banner_startapp_id").hide();
        $(".banner_size_add").hide();
        $(".p_ad_id").hide();
        $(".p_app_id").hide();
        $(".p_app_id").hide();
        $(".p_game_id").show();
        $(".banner_unity_id").show();
        $(".banner_size_iron").hide();
        $(".p_app_key").hide();
        $(".banner_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'iron') {
        $(".banner_size_fb").hide();
        $(".banner_facebook_id").hide();
        $(".banner_ad_id").hide();
        $(".banner_size").hide();
        $(".banner_startapp_id").hide();
        $(".banner_size_add").show();
        $(".p_ad_id").hide();
        $(".p_app_id").hide();
        $(".p_app_id").hide();
        $(".p_game_id").hide();
        $(".banner_unity_id").hide();

        $(".banner_size_iron").show();
        $(".p_app_key").show();
        $(".banner_iron_id").show();
    }

    $("select[name='banner_ad_type']").change(function (e) {
        if ($(this).val() === 'facebook') {
            $(".banner_size_fb").show();
            $(".banner_facebook_id").show();
            $(".banner_ad_id").hide();
            $(".banner_size").hide();
            $(".banner_startapp_id").hide();
            $(".banner_size_add").show();
            $(".p_ad_id").show();
            $(".p_app_id").hide();
            $(".p_game_id").hide();
            $(".banner_unity_id").hide();
            $(".banner_size_iron").hide();
            $(".p_app_key").hide();
            $(".banner_iron_id").hide();
        } else if ($(this).val() === 'admob') {
            $(".banner_size_fb").hide();
            $(".banner_facebook_id").hide();
            $(".banner_ad_id").show();
            $(".banner_size").show();
            $(".banner_startapp_id").hide();
            $(".banner_size_add").show();
            $(".p_ad_id").show();
            $(".p_app_id").hide();
            $(".p_game_id").hide();
            $(".banner_unity_id").hide();
            $(".banner_size_iron").hide();
            $(".p_app_key").hide();
            $(".banner_iron_id").hide();
        } else if ($(this).val() === 'startapp') {
            $(".banner_size_fb").hide();
            $(".banner_facebook_id").hide();
            $(".banner_ad_id").hide();
            $(".banner_size").hide();
            $(".banner_startapp_id").show();
            $(".banner_size_add").hide();
            $(".p_ad_id").hide();
            $(".p_app_id").show();
            $(".p_game_id").hide();
            $(".banner_unity_id").hide();
            $(".banner_size_iron").hide();
            $(".p_app_key").hide();
            $(".banner_iron_id").hide();
        } else if ($(this).val() === 'unity') {
            $(".banner_size_fb").hide();
            $(".banner_facebook_id").hide();
            $(".banner_ad_id").hide();
            $(".banner_size").hide();
            $(".banner_startapp_id").hide();
            $(".banner_size_add").hide();
            $(".p_ad_id").hide();
            $(".p_app_id").hide();
            $(".p_app_id").hide();
            $(".p_game_id").show();
            $(".banner_unity_id").show();
            $(".banner_size_iron").hide();
            $(".p_app_key").hide();
            $(".banner_iron_id").hide();
        } else if ($(this).val() === 'iron') {
            $(".banner_size_fb").hide();
            $(".banner_facebook_id").hide();
            $(".banner_ad_id").hide();
            $(".banner_size").hide();
            $(".banner_startapp_id").hide();
            $(".banner_size_add").show();
            $(".p_ad_id").hide();
            $(".p_app_id").hide();
            $(".p_app_id").hide();
            $(".p_game_id").hide();
            $(".banner_unity_id").hide();

            $(".banner_size_iron").show();
            $(".p_app_key").show();
            $(".banner_iron_id").show();
        }
    });

    // Interstital
    if ($("select[name='interstital_ad_type']").val() === 'facebook') {
        $(".interstital_ad_id").hide();
        $(".interstital_facebook_id").show();
        $(".interstital_startapp_id").hide();
        $(".i_ad_id").show();
        $(".i_app_id").hide();
        $(".i_game_id").hide();
        $(".i_app_key").hide();
        $(".interstital_unity_id").hide();
        $(".interstital_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'admob') {
        $(".interstital_facebook_id").hide();
        $(".interstital_ad_id").show();
        $(".interstital_startapp_id").hide();
        $(".i_ad_id").show();
        $(".i_app_id").hide();
        $(".i_game_id").hide();
        $(".i_app_key").hide();
        $(".interstital_unity_id").hide();
        $(".interstital_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'startapp') {
        $(".interstital_facebook_id").hide();
        $(".interstital_ad_id").hide();
        $(".interstital_startapp_id").show();
        $(".i_ad_id").hide();
        $(".i_app_id").show();
        $(".i_game_id").hide();
        $(".i_app_key").hide();
        $(".interstital_unity_id").hide();
        $(".interstital_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'unity') {
        $(".interstital_facebook_id").hide();
        $(".interstital_ad_id").hide();
        $(".interstital_startapp_id").hide();
        $(".i_ad_id").hide();
        $(".i_app_id").hide();
        $(".i_game_id").show();
        $(".i_app_key").hide();
        $(".interstital_unity_id").show();
        $(".interstital_iron_id").hide();
    } else if ($("select[name='banner_ad_type']").val() === 'iron') {
        $(".interstital_facebook_id").hide();
        $(".interstital_ad_id").hide();
        $(".interstital_startapp_id").hide();
        $(".i_ad_id").hide();
        $(".i_app_id").hide();
        $(".i_game_id").hide();
        $(".i_app_key").show();
        $(".interstital_unity_id").hide();
        $(".interstital_iron_id").show();
    }

    $("select[name='interstital_ad_type']").change(function (e) {
        if ($(this).val() === 'facebook') {
            $(".interstital_ad_id").hide();
            $(".interstital_facebook_id").show();
            $(".interstital_startapp_id").hide();
            $(".i_ad_id").show();
            $(".i_app_id").hide();
            $(".i_game_id").hide();
            $(".i_app_key").hide();
            $(".interstital_unity_id").hide();
            $(".interstital_iron_id").hide();
        } else if ($(this).val() === 'admob') {
            $(".interstital_facebook_id").hide();
            $(".interstital_ad_id").show();
            $(".interstital_startapp_id").hide();
            $(".i_ad_id").show();
            $(".i_app_id").hide();
            $(".i_game_id").hide();
            $(".i_app_key").hide();
            $(".interstital_unity_id").hide();
            $(".interstital_iron_id").hide();
        } else if ($(this).val() === 'startapp') {
            $(".interstital_facebook_id").hide();
            $(".interstital_ad_id").hide();
            $(".interstital_startapp_id").show();
            $(".i_ad_id").hide();
            $(".i_app_id").show();
            $(".i_game_id").hide();
            $(".i_app_key").hide();
            $(".interstital_unity_id").hide();
            $(".interstital_iron_id").hide();
        } else if ($(this).val() === 'unity') {
            $(".interstital_facebook_id").hide();
            $(".interstital_ad_id").hide();
            $(".interstital_startapp_id").hide();
            $(".i_ad_id").hide();
            $(".i_app_id").hide();
            $(".i_game_id").show();
            $(".i_app_key").hide();
            $(".interstital_unity_id").show();
            $(".interstital_iron_id").hide();
        } else if ($(this).val() === 'iron') {
            $(".interstital_facebook_id").hide();
            $(".interstital_ad_id").hide();
            $(".interstital_startapp_id").hide();
            $(".i_ad_id").hide();
            $(".i_app_id").hide();
            $(".i_game_id").hide();
            $(".i_app_key").show();
            $(".interstital_unity_id").hide();
            $(".interstital_iron_id").show();
        }
    });


    // Native
    if ($("select[name='native_ad_type']").val() === 'facebook') {
        $(".native_ad_id").hide();
        $(".native_facebook_id").show();
        $(".native_startapp_id").hide();
        $(".n_ad_id").show();
        $(".n_app_id").hide();
        $(".n_game_id").hide();
        $(".n_app_key").hide();
        $(".native_unity_id").hide();
        $(".native_iron_id").hide();
    } else if ($("select[name='native_ad_type']").val() === 'admob') {
        $(".native_facebook_id").hide();
        $(".native_ad_id").show();
        $(".native_startapp_id").hide();
        $(".n_ad_id").show();
        $(".n_app_id").hide();
        $(".n_game_id").hide();
        $(".n_app_key").hide();
        $(".native_unity_id").hide();
        $(".native_iron_id").hide();
    } else if ($("select[name='native_ad_type']").val() === 'startapp') {
        $(".native_facebook_id").hide();
        $(".native_ad_id").hide();
        $(".native_startapp_id").show();
        $(".n_ad_id").hide();
        $(".n_app_id").show();
        $(".n_game_id").hide();
        $(".n_app_key").hide();
        $(".native_unity_id").hide();
        $(".native_iron_id").hide();
    } else if ($("select[name='native_ad_type']").val() === 'unity') {
        $(".native_facebook_id").hide();
        $(".native_ad_id").hide();
        $(".native_startapp_id").hide();
        $(".n_ad_id").hide();
        $(".n_app_id").hide();
        $(".n_game_id").show();
        $(".n_app_key").hide();
        $(".native_unity_id").show();
        $(".native_iron_id").hide();
    } else if ($("select[name='native_ad_type']").val() === 'iron') {
        $(".native_facebook_id").hide();
        $(".native_ad_id").hide();
        $(".native_startapp_id").hide();
        $(".n_ad_id").hide();
        $(".n_app_id").hide();
        $(".n_game_id").hide();
        $(".n_app_key").show();
        $(".native_unity_id").hide();
        $(".native_iron_id").show();
    }

    $("select[name='native_ad_type']").change(function (e) {
        if ($(this).val() === 'facebook') {
            $(".native_ad_id").hide();
            $(".native_facebook_id").show();
            $(".native_startapp_id").hide();
            $(".n_ad_id").show();
            $(".n_app_id").hide();
            $(".n_app_key").hide();
            $(".n_game_id").hide();
            $(".native_unity_id").hide();
            $(".native_iron_id").hide();
        } else if ($(this).val() === 'admob') {
            $(".native_facebook_id").hide();
            $(".native_ad_id").show();
            $(".native_startapp_id").hide();
            $(".n_ad_id").show();
            $(".n_app_id").hide();
            $(".n_app_key").hide();
            $(".n_game_id").hide();
            $(".native_unity_id").hide();
            $(".native_iron_id").hide();
        } else if ($(this).val() === 'startapp') {
            $(".native_facebook_id").hide();
            $(".native_ad_id").hide();
            $(".native_startapp_id").show();
            $(".n_ad_id").hide();
            $(".n_app_id").show();
            $(".n_game_id").hide();
            $(".n_app_key").hide();
            $(".native_unity_id").hide();
            $(".native_iron_id").hide();
        } else if ($(this).val() === 'unity') {
            $(".native_facebook_id").hide();
            $(".native_ad_id").hide();
            $(".native_startapp_id").hide();
            $(".n_ad_id").hide();
            $(".n_app_id").hide();
            $(".n_game_id").show();
            $(".n_app_key").hide();
            $(".native_unity_id").show();
            $(".native_iron_id").hide();
        } else if ($(this).val() === 'iron') {
            $(".native_facebook_id").hide();
            $(".native_ad_id").hide();
            $(".native_startapp_id").hide();
            $(".n_ad_id").hide();
            $(".n_app_id").hide();
            $(".n_game_id").hide();
            $(".n_app_key").show();
            $(".native_unity_id").hide();
            $(".native_iron_id").show();
        }
    });

}