<?php
session_start();

include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once LIBSDIR .'/helpers.php';
require_once LIBSDIR .'/icons.php';
require_once SERVERDIR .'/auth.php';

requireLogIn();
?>

<!DOCTYPE html>
 <html>
    <!-- BEIGN HEAD -->
    <?php view('header', ['title' => 'Manage Admin']) ?>
    <!-- END HEAD -->
   <body>
    
     <!--  BEGIN NAVBAR  -->
     <?php view('navbar') ?>
     <!--  END NAVBAR  -->

     <!--  BEGIN SUBNAVBAR  -->
     <?php view('subnavbar', ['title' => 'Manage Admin']) ?>
     <!--  END SUBNAVBAR  -->
     <div class="main-container" id="container">
    
       <!--  BEGIN SIDEBAR  -->
       <?php view('sidebar') ?>
       <!--  END SIDEBAR  -->
     
       <div id="content" class="main-content">
        <div class="layout-px-spacing">
              <!-- Start Content -->
                 <!-- The Modal -->
              <div class="modal" id="edit-user-modal">
                  <div class="modal-dialog">
                    <div class="modal-content">

                        <!-- Modal Header -->
                        <div class="modal-header">
                          <h4 class="modal-title">Edit Admin</h4>
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                        </div>

                        <!-- Modal body -->
                        <div class="modal-body">
                          <form action="server/users.db.php" id="update-user-form">
                              <input class="form-control" type="hidden" name="identifier">

                              <div class="form-group">
                                <label for="full_name">Name</label>
                                <input class="form-control" type="text" name="full_name">
                              </div>
                              <div class="form-group">
                                <label for="email">Email</label>
                                <input class="form-control" type="email" name="email">
                              </div>
                             
                              <div class="form-group">
                                <label for="profile">Profile</label>
                                <input class="form-control" type="text" name="profile">
                              </div>

                              <div class="form-group d-none">
                                <label for="address">Address</label>
                                <textarea class="form-control" type="text" name="address" rows="3"></textarea>
                              </div>

                              <button type="button" class="btn btn-primary" id="btnUpdateUserSubmit">Update</button>
                              <button type="button" class="btn btn-danger float-right" data-dismiss="modal">Close</button>
                          </form>
                        </div>
                    </div>
                  </div>
              </div>


              <div class="modal" id="delete-user-modal">
                  <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">

                        <!-- Modal Header -->
                        <div class="modal-header">
                          <h4 class="modal-title">Delete Admin</h4>
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                        </div>

                        <!-- Modal body -->
                        <div class="modal-body">
                          <form action="" id="delete-form">
                              <input class="form-control" type="hidden" name="id">

                               <p>Are you sure to want to delete the admin?</p>

                               <div class="modal-footer">
                                <button type="button" class="btn btn-danger" id="btnDeleteUserSubmit">Yes</button>
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
                              </div>
                          </form>
                        </div>
                    </div>
                  </div>
              </div>

               <div class="row layout-top-spacing">
                <div class="col-xl-12 col-lg-12 col-md-12 col-12 layout-spacing">
                <div class="widget-content widget-content-area br-6">
                    <div class=" mt-2">
                    <div class="row">
                        <div class="col-sm-8 m-auto p-auto">
                        <h3 class="mr-1">Manage Admin</h3>
                        </div>
                        <div class="col-sm-4 m-auto p-auto">
                        <div class="search_list m-auto p-auto">
                            <div class="add_btn_primary">
                            <a href="add_admin.php">Add Admin</a>
                            </div>
                        </div>
                        </div>
                    </div>
                    </div>
                    <div style="border-bottom: 1px solid #f1f2f3; margin-top: 20px; margin-bottom: 20px;"></div>
                    
                    <div class="row">

                      <?php view('usersRow') ?>

                      <div id="loading-users" class="container text-center"></div>

                      <div class="col-md-12 col-xs-12">
                       <div class="paginating-container pagination-default" id="users-pagination"></div>
                      </div>

                    </div>

                </div>
                </div>
               </div>
              <!-- End Content -->         
        </div>
        <!--  BEIGN FOOTER -->
        <?php view('footer') ?>
        <!--  END FOOTER -->
       </div>
      
     </div>
     <!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
     <?php view('globalscript') ?>
     <!-- END GLOBAL MANDATORY SCRIPTS -->
     <script>
       $(document).ready(function() {
         Users.getUsers('admins', 1, 5);
       });
     </script>
   </body>
 </html>