<?php
session_start();

include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once LIBSDIR .'/helpers.php';
require_once LIBSDIR .'/icons.php';
require_once SERVERDIR .'/auth.php';

requireLogIn();

?>

<!DOCTYPE html>
 <html>
    <!-- BEIGN HEAD -->
    <?php view('header', ['title' => 'Manage Wallpaper']) ?>
    <!-- END HEAD -->
   <body>
    
     <!--  BEGIN NAVBAR  -->
     <?php view('navbar') ?>
     <!--  END NAVBAR  -->

     <!--  BEGIN SUBNAVBAR  -->
     <?php view('subnavbar', ['title' => 'Manage Wallpaper']) ?>
     <!--  END SUBNAVBAR  -->
     <div class="main-container" id="container">
    
       <!--  BEGIN SIDEBAR  -->
       <?php view('sidebar') ?>
       <!--  END SIDEBAR  -->
     
       <div id="content" class="main-content">
        <div class="layout-px-spacing">
              <!-- Start Content -->

              <!-- The Modal -->
              <div class="modal" id="edit-wallpaper-modal">
                  <div class="modal-dialog">
                    <div class="modal-content">

                        <!-- Modal Header -->
                        <div class="modal-header">
                          <h4 class="modal-title">Edit Wallpaper</h4>
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                        </div>

                        <!-- Modal body -->
                        <div class="modal-body">
                          <div id="alert-message"></div>

                          <form action="server/wallpapers.db.php" id="edit-wallpaper-form">
                              <input class="form-control" type="hidden" name="identifier">

                              <div class="form-group">
                                <label for="name">Name</label>
                                <input class="form-control" type="text" name="wallpaper_name">
                              </div>
                            
                             
                              <div class="form-group">
                                <label for="url">URL</label>
                                <input class="form-control" type="text" name="wallpaper_url">
                              </div>

                              <div class="modal-body text-center">
                                <img src="assets/img/no_photo.svg" id="wallpaper_preview" style="width: 250px; height: 400px;border-radius:1%;" >
                              </div>

                              <button type="button" class="btn btn-primary" id="btnUpdateWallpaperSubmit">Update</button>
                              <button type="button" class="btn btn-danger float-right" data-dismiss="modal">Close</button>
                          </form>
                        </div>
                    </div>
                  </div>
              </div>


              <div class="modal" id="delete-wallpaper-modal">
                  <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">

                        <!-- Modal Header -->
                        <div class="modal-header">
                          <h4 class="modal-title">Delete Wallpaper</h4>
                          <button type="button" class="close" data-dismiss="modal">&times;</button>
                        </div>

                        <!-- Modal body -->
                        <div class="modal-body">
                          <form action="" id="delete-wallpaper-form">
                              <input class="form-control" type="hidden" name="id">

                               <p>Are you sure to want to delete the wallpaper?</p>

                               <div class="modal-footer">
                                <button type="button" class="btn btn-danger" id="btnDeleteWallpaperSubmit">Yes</button>
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
                              </div>
                          </form>
                        </div>
                    </div>
                  </div>
              </div>

              <div class="row layout-top-spacing">
                  <?php view('wallpaperRow') ?>
               </div>
              <!-- End Content -->         
        </div>
        <!--  BEIGN FOOTER -->
        <?php view('footer') ?>
        <!--  END FOOTER -->
       </div>
      
     </div>
     <!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
     <?php view('globalscript') ?>
     <!-- END GLOBAL MANDATORY SCRIPTS -->
     <script>

       $(document).ready(function() {
          Wallpapers.getWallpapers(1, 12); 
          SearchWallpaper.init();

          const myInput = document.querySelector('input[name="wallpaper_url"]');
          myInput.addEventListener("input", (e) => {
            // here we do something
            console.log("URL", myInput.value);
              if(isValidHttpUrl(myInput.value)) {
                 $("#wallpaper_preview").attr('src', myInput.value)
              } else {
                $("#wallpaper_preview").attr('src', 'assets/img/no_photo.svg')
              }
          });
        });

       function onErrorImage(event) {
            var $image = $(event);
            console.log("On Image Error");
            $image.attr('src', 'assets/img/image-placeholder.png').addClass('no_image');
            $image.css('object-fit', 'none');
       }

       function onLoadImage(event, url) {
            //var $image = $(event);
            //console.log('On Load Image ' + url);
            var $image = $(event);
            $image.attr('src', url);

            const link = new URL(url);
            const isValidHttpUrl = link.protocol === "http:" || link.protocol === "https:";
            if(isValidHttpUrl) {
              $image.css('object-fit', 'cover');
            }
       }
     </script>
   </body>
 </html>