<?php
session_start();

include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once LIBSDIR .'/helpers.php';
require_once LIBSDIR .'/icons.php';
require_once SERVERDIR .'/auth.php';

redirectIfUserLogedIn();
?>

<!doctype html>
<html class="no-js " lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="icon" href="assets/img/app_icon.png" sizes="32x32">
    <link rel="icon" href="assets/img/app_icon.png" sizes="192x192">
    <link rel="apple-touch-icon-precomposed" href="assets/img/app_icon.png">
    <meta name="msapplication-TileImage" content="assets/img/app_icon.png">
    <meta http-equiv="Content-Security-Policy" content="upgrade-insecure-requests">
    <title>Wallpaper ~ Registration</title>

    <link href="https://fonts.googleapis.com/css?family=Nunito:400,600,700" rel="stylesheet">
    <link href="assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
    <link href="assets/css/font-awesome.css" rel="stylesheet" type="text/css" />
    <link href="assets/css/main.css" rel="stylesheet" type="text/css" />
    <link href="assets/css/structure.css" rel="stylesheet" type="text/css" />

    
    <!-- END GLOBAL MANDATORY STYLES -->
    <link rel="stylesheet" type="text/css" href="assets/css/forms/theme-checkbox-radio.css">
    <link rel="stylesheet" type="text/css" href="assets/css/forms/switches.css">
    <link rel="stylesheet" type="text/css" href="assets/css/elements/alert.css">

    <link href="assets/css/authentication.css" rel="stylesheet" type="text/css" />

</head>

<body class="form">
    <div class="form-container outer bg-image shadow-2-strong">
     <div class="mask d-flex align-items-center h-100" style="background-color: rgba(0, 0, 0, 0.8);">
        <div class="form-form">
            <div class="form-form-wrap">
                <div class="form-container">
                    <div class="form-content">
                     
                     <h1 class="">Sign Up</h1>
                     <p class="">Create new account.</p>

                     <div id="register-alert"></div>
                    
                     <!-- </?php $_SERVER['PHP_SELF']; ?> -->
                     <form action="server/signup.db.php" method="post" accept-charset="utf-8" class="text-left" target="_self" onsubmit="return validateInputs();" id="register-form">
                         <div class="form">

                                <!-- <div class="row">
                                    <div class="col-lg-6 col-md-6">
                                      <div id="gender-field" class="field-wrapper input">
                                        <label for="gender">GENDER</label>
                                        <select name="gender" id="gender" class="form-control col-md-12">
                                          <option value="">--Select Gender--</option> 
                                        <option value="male">Male</option>
                                        <option value="female">Female</option>
                                        </select>
                                      </div>
                                    </div>

                                    <div class="col-lg-6 col-md-6">
                                      <div id="gender-field" class="field-wrapper input">
                                        <label for="gender">COUNTRY</label>
                                        <select name="country" id="country" class="form-control col-md-12">
                                          <option value="">--Select Country--</option> 
                                        <option value="morocco">Morocco</option>
                                        </select>
                                      </div>
                                    </div>
                                </div> -->
                             
                                <!-- <div id="fullname-field" class="field-wrapper input">
                                    <label for="fullname">FULL NAME</label>
                                    </?= editIcon2() ?>
                                    <input id="fullname" name="fullname" type="text" value="Test" class="form-control" placeholder="Full name" aria-describedby="basic-addon1" required>
                                </div> -->

                                <div id="username-field" class="field-wrapper input">
                                    <label for="username">USERNAME</label>
                                    <?= userIcon() ?>
                                    <input id="username" name="username" type="text" value="admin" class="form-control" placeholder="User name" aria-describedby="basic-addon1" required>
                                </div>
                                

                                <div id="email-field" class="field-wrapper input">
                                    <label for="email">EMAIL</label>
                                    <?= atSignIcon() ?>
                                    <input id="email" name="email" type="email" value="admin@itsmed.com" class="form-control" placeholder="Email" aria-describedby="basic-addon1" required>
                                </div>

                                <div id="password-field" class="field-wrapper input mb-2">
                                    <div class="d-flex justify-content-between">
                                        <label for="password">PASSWORD</label>
                                    </div>
                                    <?= lockIcon() ?>
                                    <input id="password" name="password" type="password" value="admin123" class="form-control" placeholder="Password" aria-describedby="basic-addon2" required>
                                    <?= eyeIcon() ?>
                                </div>
                                <div class="d-sm-flex justify-content-between">
                                    <div class="field-wrapper">
                                        <button type="submit" class="btn btn-primary btn-login" id="register" name="register" value="register">Sign Up</button>
                                    </div>
                                </div>

                                 <div id="register-field" class="field-wrapper input mb-2">
                                    <div class="d-sm-flex justify-content-between">
                                        <div class="field-wrapper">
                                            <div class="col text-center">
                                                <!-- Simple link -->
                                                Already have an account? <a href="login.php">Log in?</a>
                                            </div>
                                        </div>
                                    </div>
                                 </div>
                                
                            </div>
                        </form>
                        <p class="signup-link">© 2022 All Rights Reserved. <a href="#">Itsmed</a>.</p>
                    </div>    
                    
 

                </div>
            </div>
        </div>
      </div>
    </div>
<!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
<script src="assets/js/libs/jquery-3.1.1.min.js"></script>
<script src="assets/bootstrap/js/popper.min.js"></script>
<script src="assets/bootstrap/js/bootstrap.min.js"></script>

<!-- END GLOBAL MANDATORY SCRIPTS -->
<script src="assets/js/authentication.js"></script>
<script src="assets/js/api.js"></script>

<script>
    $(document).ready(function() {
        Authentication.initialize("register");
    });
</script>

</body>
</html>