<?php
session_start();

include_once('../config.php');
$pdo = require_once  SERVERDIR .'/database.php';
require_once SERVERDIR .'/auth.php';
require_once LIBSDIR .'/variables.php';

const MESSAGES = [
    'INVALID_PASSWORD' => 'Invalid password.',
    'USER_PASSWORD_INCORRECT' => 'Username & password incorrect.',
    'USER_NO_EXISTS' => 'not exists.',
    'LOGIN_SUCCESS' => 'Login Successfuly.'
];

if(isPostRequest()) {
    if(isset($_REQUEST["username"]) && isset($_REQUEST["password"])) {
        if(!empty($_REQUEST['username']) && !empty($_REQUEST['password'])) {
            $username =  escape('username');
            $password = escape('password');
            $remember = escape('remember_me');
            login();
        } else {
            print json_encode(array("success" => false, "msg" => "All fields required"), JSON_PRETTY_PRINT);
        }
    } 
}

function checkUsernameExists(): bool {
    global $pdo, $username;
    $sql = 'SELECT * FROM `tb_users` WHERE (username = :username)'; 
    $stmt = $pdo->prepare($sql);
    $stmt->bindValue(':username', $username, PDO::PARAM_STR); 
    $stmt->execute();
    $numRow = $stmt->fetchColumn();
    return $numRow > 0 ? true : false;
}

function login() {
    global $pdo, $username, $password, $remember, $loginSuccess, $loginStateMsg, $coockie;

    if(checkUsernameExists()) {
        $sql = 'SELECT username, password, level FROM `tb_users` WHERE (username = :username)'; 
        $stmt = $pdo->prepare($sql);
        $stmt->bindValue(':username', $username, PDO::PARAM_STR); 
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        if($row) {
            if(password_verify($password, $row['password'])) {
                //$_SESSION['userid'] = $fetchUser['id'];
                $_SESSION['username'] = $row['username'];
                $_SESSION['level'] = $row['level'];
               
                //$options = array("cost"=>4);
                //$password = md5($password);

                //$hashPassword =  password_hash($password, PASSWORD_BCRYPT, $options);

                // $string = 'c4ca4238a0b923820dcc';
                // $encrypted = \Illuminate\Support\Facades\Crypt::encrypt($string);
                // $decrypted_string = \Illuminate\Support\Facades\Crypt::decrypt($encrypted);

                if(!empty($remember)) {
                     $_SESSION['last_loggedin'] = time();
                    //setcookie('username', $username, time() + (86400 * 30), "/"); // 86400 = 1 day
                    //setcookie("username", $username, (time()+3600), "/");// second on page time 
                    //setcookie("password", encryptIt($password), (time()+3600), "/");// second on page time 
                    $coockie = 'Cookies Set Successfuly ';
                } else {
                    //setcookie("u", "");
                    //setcookie("p", ""); 
                    $coockie = 'Cookies Not Set';
                }
                
                $stmt->closeCursor();
    
                $loginSuccess = true;
                $loginStateMsg =  MESSAGES['LOGIN_SUCCESS'];
            } else  {
                $loginSuccess = false;
                $loginStateMsg = MESSAGES['INVALID_PASSWORD'];
            }
        } else {
            $loginSuccess = false;
            $loginStateMsg = MESSAGES['USER_PASSWORD_INCORRECT'];
        }
    } else {
        $loginSuccess = false;
        $loginStateMsg = $username . ' ' . MESSAGES['USER_NO_EXISTS'];
    }
    print json_encode(array("success" => $loginSuccess, "msg" => $loginStateMsg, 'coockie' => $coockie), JSON_PRETTY_PRINT);
}
?>