<?php
session_start();
include_once ('../config.php');
$pdo = require_once (SERVERDIR .'/database.php');
require_once (LIBSDIR .'/variables.php');
require_once (SERVERDIR .'/auth.php');

if(isPostRequest() && isUserLogedIn()) {
    // Users
    if(isset($_REQUEST['fetchAllReports'])) {
        getReportsPagination($_REQUEST['page'], $_REQUEST['perpage']);
    } 
}

function getReportsPagination($page, $perpage) { 
    global $pdo;

    $contentHtml = '';
    $paginationHtml = '';  
    $start = ($page -1) * $perpage;
    $rowCount = reportCount();

    $query = "SELECT * FROM `tb_reports` ORDER BY `id` DESC LIMIT " .$start. "," . $perpage ;
    
    $stmt = $pdo->prepare($query);
    $stmt->execute();
    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    
    // Records
    if($rowCount) {
        // Content
        foreach($rows as $report) {
            $contentHtml .= '<tr role="row">';
            $contentHtml .= '<td style="word-break: break-all;">#' . $report['id'] . '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $report['subject'] . '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $report['name'] . '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $report['email'] . '</td>';
            $contentHtml .= '<td><img alt="avatar" src="'.$report['wallpaper_url'].'" class="rounded-circle  bs-tooltip" style="height: 65px;width: 65px; border: 1px solid #dadce0; object-fit: cover;" data-toggle="tooltip" title="' .$report['created_at']. ' " /></td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $report['report'] . '</td>';
            $contentHtml .= '<td class="text-center">';
            $contentHtml .= '<a href="javascript:void(0)" class="btn btn-dark btn_delete bs-tooltip" data-id="' . $report['ticket_id'] . '" data-toggle="modal" data-target="#edit-employee-modal" data-placement="top" title="Delete" style="padding: 5px 10px !important;">';
            $contentHtml .= '<i class="fa fa-trash"></i>';
            $contentHtml .= '</a>';
            $contentHtml .= '</td>';
            $contentHtml .= '</tr>';
        }

        // Pagination
        if($rowCount > $perpage) {
            $pages = ceil($rowCount / $perpage);
        
            $next = $page;
        
            $paginationHtml .= '<div class="col-md-12 col-xs-12">';
            $paginationHtml .= '<div class="paginating-container pagination-default">';
            $paginationHtml .= '<ul class="pagination">';
        
            $previous = $page - 1;
        
            $paginationHtml .= '<script>console.log("Pages: ' .$pages. ' ")</script>';
            $paginationHtml .+ '****************************************************';
            $paginationHtml .= '<script>console.log("Current Page: ' .$page. ' ")</script>';
        
            $paginationHtml .= '<script>console.log("Previous Page: ' .$previous. ' ")</script>';
        
            if($previous !== 0) {
                $paginationHtml .= '<li class="pag-link first" id="1"><a>First</a></li>';
                $paginationHtml .= '<li class="pag-link prev" id='.$previous.'><a>Prev</a></li>';
            } else {
                $paginationHtml .= '<li class="first" aria-disabled="true"><a>First</a></li>';
                $paginationHtml .= '<li class="prev"><a aria-disabled="true">Prev</a></li>';
            } 
        
            for($i = 1; $i <= $pages; $i++) {
                if($i == $page) {
                    $paginationHtml .= '<li class="pag-link active" id='.$i.'><a>'.$i.'</a></li>';
                } else {
                    $paginationHtml .= '<li class="pag-link" id='.$i.'><a>'.$i.'</a></li>';
                }
            }
            if($page < $pages) {
                $paginationHtml .= '<li class="pag-link next" id='.($next += 1).'><a>Next</a></li>';
                $paginationHtml .= '<li class="pag-link last" id='.$pages.'><a>Last</a></li>';
            } else {
                $paginationHtml .= '<li class="next" aria-disabled="true"><a>Next</a></li>';
                $paginationHtml .= '<li class="last"><a aria-disabled="true">Last</a></li>';
            }
            $paginationHtml .= '</ul>';
            $paginationHtml .= '</div>';
            $paginationHtml .= '</div>';
      }
    } else {
        $contentHtml .= '<div class="container">';
        $contentHtml .= '<div class="text-center">';
        $contentHtml .= '<img src="assets/img/no_photo.svg" at="..." style="width: 100px;height:100px;"></img>';
        $contentHtml .= '<h4>No report found!</h4>';
        $contentHtml .= '</div>';
        $contentHtml .= '</div>';
    }   

    print json_encode(array('content' => $contentHtml, 'pagination' => $paginationHtml), JSON_PRETTY_PRINT);
}

function getAllReports() {
    global $pdo;
    $sql = 'SELECT * FROM `tb_reports`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $fetchAllUsers = $statment->fetchAll(PDO::FETCH_ASSOC);
    $statment->closeCursor();
    return $fetchAllUsers;
}

function getReportById($id) {
    global $pdo;
    $sql = "SELECT * FROM `tb_reports` WHERE identifier =  $id "; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $fetchUser = $statment->fetch(PDO::FETCH_ASSOC);
    $statment->closeCursor();
    return $fetchUser;
}

function reportCount() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_reports`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
}

?>