"use strict";
var Api = function () {
 
    const wallpapers = {
        all: function () {
            console.log("Get Wallpapers");
            // Ajax config
            $.ajax({
                type: "GET", //we are using GET method to get all record from the server
                url: 'server/wallpapers.db.php', // get the route value
                data: {
                    fetchAllWallpapers: 0
                },
                success: function (response) { //once the request successfully process to the server side it will return result here
                    // Parse the json result
                    response = JSON.parse(response);

                    console.log(response.wallpapers);

                    //var count = Object.keys(response).length;
                    //var cell = Math.ceil(count / 6);
                    //console.log("Total Items " + cell);

                    var html = "";
                    // Check if there is available records
                    if (response.wallpapers.length) {
                        // Loop the parsed JSON
                        $.each(response.wallpapers, function (key, value) {
                            console.log(value.usr_email);
                            // Our employee list template
                            html += '<div class="col-lg-2 col-md-3 col-sm-6 col-xs-3">';
                            html += '<div class="card profile-card-1">';
                            html += '<img src="' + value.img_url + '" style="height: 100%;">';
                            html += '<div class="card-img-overlay bg-overlay">';
                            html += '<div class="card-content">';
                            html += '<div class="icon-block">';
                            html += '<a href="javascript:void(0)" class="bs-tooltip" data-placement="top" title="" data-original-title="' + value.img_views + ' Views"><i class="fa fa-eye"></i></a>';
                            html += '<a href="javascript:void(0)" class="bs-tooltip" data-placement="top" title="" data-original-title="' + value.img_downloads + ' Download"><i class="fa fa-download"></i></a>';
                            html += '<a href="javascript:void(0)" class="bs-tooltip" data-placement="top" title="" data-original-title="Edit" data-toggle="modal" data-target="#exampleModalCenter"><i class="fa fa-edit"></i></a>';
                            html += '<a href="javascript:void(0)" class="bs-tooltip" data-placement="top" title="" data-original-title="Delete" data-toggle="modal" data-target="#exampleModalCenter"><i class="fa fa-trash"></i></a>';
                            html += '</div>';
                            html += '</div>';
                            html += '</div>';
                            html += '</div>';
                            html += '</div>';
                        });
                        //html += '</div>';
                    } else {
                        html += '<div class="container">';
                        html += '<div class="text-center">';
                        html += '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-frown">';
                        html += '<circle cx="12" cy="12" r="10"></circle><path d="M16 16s-1.5-2-4-2-4 2-4 2"></path><line x1="9" y1="9" x2="9.01" y2="9"></line><line x1="15" y1="9" x2="15.01" y2="9"></line>';
                        html += '</svg>';
                        html += '<h4 style="color: red;">No records found!</h4>';
                        html += '</div>';
                        html += '</div>';
                    }

                    // Insert the HTML Template and display all employee records

                    $("#wallpapers-list").html(html);
                }
            });
        },
        add: function () {
            console.log("Ready to submit wallpaper");
            $("#addwallpaper").on("click", function () {
                const $this = $(this);
                const $caption = $this.html();
                const formId = "#form-addwallpaper";
                const formDataAddWallpaper = $(formId).serializeArray();
                const route = $(formId).attr('action');

                var html = '';
                // Ajax config
                $.ajax({
                    type: "POST", //we are using GET method to get data from server side
                    url: route, // get the route value
                    data: formDataAddWallpaper, //set data
                    beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                        $this.attr('disabled', true).html("Processing...");
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        $this.attr('disabled', false).html($caption);
                        response = JSON.parse(response);

                        if (response.success) {
                            html += '<div class="alert alert-success" role="alert" data-mdb-color="success">';
                            html += '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += 'Wallpaper has been successfuly added.';
                            html += '</div>';
                            $(formId)[0].reset();
                            window.setTimeout(function () {
                                $("#alert-message").fadeTo(500, 0).slideUp(500, function () {
                                    $(this).remove();
                                    //window.location.reload();
                                });
                            }, 2000);
                        } else {
                            html += '<div class="alert alert-info" role="alert" data-mdb-color="info">';
                            html += '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += 'Wallpaper add faied.';
                            html += '</div>';
                        }
                        $("#alert-message").html(html);
                        console.log(response);
                        //$("#edit-form [name=\"id\"]").val(response._id);
                    }
                });
            })
        }
    }

    const reports = {
        all: function (page, perpage) {
            const results = $("#reports-list"); // Our results DIV that will store our results
            const table = $(".reports-table"); // Our results DIV that will store our results
            const pagination = $("#reports-pagination"); // Our results DIV that will store our results
            const loadingDiv = $("#reports-loading");

            var html = '';

            getReports(page, true);

            function getReports(page, loading) {
                $.ajax({
                    type: "post", //we are using GET method to get all record from the server
                    url: 'server/reports.db.php', // get the route value
                    data: {
                        fetchAllReports: 1,
                        page: page,
                        perpage: perpage
                    },
                    beforeSend: function () {
                        html += '<div class="container">';
                        html += '<div class="text-center">';
                        html += '<img src="assets/img/loading-hourglass.svg" at="..." style="width: 100px;height:100px;"></img>';
                        html += '<h6>Loading reports...</h6>';
                        html += '</div>';
                        html += '</div>';
                        $(loadingDiv).html(html);
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here

                        // Parse the json result
                        response = JSON.parse(response);
                        const noData = response.content.includes("No report found"); // true

                        if (noData) {
                            $(pagination).remove();
                            $(loadingDiv).html(response.content);
                        } else {
                            if (loading) {
                                $(results).html(response.content);
                                $(pagination).html(response.pagination);
                                $(table).removeClass('d-none');
                            }
                            $(loadingDiv).remove();
                            $(".pag-link").on("click", function () {
                                let page = $(this).attr("id"); //Get ID of clicked pagination number
                                getReports(page, true); //pass the ID into our function
                                //console.log(page);    
                            });
                        }

                        $('[data-toggle="tooltip"]').tooltip({
                            placement: 'top'
                        });
                    },
                    error: function (error) {
                        html = '';
                        error = JSON.parse(JSON.stringify(error));
                        console.log(error);

                        if (error != null && error.status != 'undefined') {
                            html += '<div class="container">';
                            html += '<div class="text-center">';
                            html += '<img src="assets/img/noun-emotion.svg" at="Error 404" style="width: 100px;height:100px;"></img>';
                            html += '<h6><strong style="color: red;">' + error.status + '</strong> Page ' + error.statusText + '</h6>';
                            html += '</div>';
                            html += '</div>';

                            $(loadingDiv).html(html);
                        }
                    }
                });
            }

        }
    }

    return {
        initialize: function (msg) {
            console.log("Api initialized is " + msg);
            wallpapers.add();
        },

        getReports: function (page, pepage) {
            reports.all(page, pepage);
        }
    }
}();

const Authentication = function() {

    const login = {
        init: function() {
            $("#login").on('click', function () {
                const $this = $(this);
                const $caption = $($this).html();
                const alert = $("#login-alert");
                const form = "#login-form";
                const formData = $(form).serializeArray();
                const route = $(form).attr('action');
    
                var html = '';
    
                $.ajax({
                    type: "post", //we are using GET method to get all record from the server
                    url: route, // get the route value
                    data: formData,
                    beforeSend: function () {
                        console.log("Before send");
                        $this.attr('disabled', true).html("Login...");
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        //$this.attr('disabled', false).html($caption);
                        // Parse the json result
                        response = JSON.parse(response);
                        if(response.success) {
                            html += '<div class="alert alert-success" role="alert" data-mdb-color="success">';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                            $(form).remove();
                            console.log("Login info ", response);
                            setTimeout(function() {
                                // Simulate a mouse click:
                                window.location.href = "index.php";
                            }, 1000);
                        } else {
                            html += '<div class="alert alert-info" role="alert" data-mdb-color="info">';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                            
                            setTimeout(function() {
                                $this.attr('disabled', false).html($caption);
                            }, 1000)
                        }
                    },
                    error: function (error) {
                        html = '';
                        error = JSON.parse(JSON.stringify(error));
                        console.log(error);
    
                        if (error != null && error.status != 'undefined') {
                            html += '<div class="alert alert-danger" role="alert" data-mdb-color="danger">';
                            html += '<strong>' + error.status + '</strong> ' + error.statusText + '';
                            html += '</div>';
                            $(alert).html(html);
                            setTimeout(function() {
                                $this.attr('disabled', false).html($caption);
                            }, 1000)
                        }
                    }
                });
            });
        }
    }

    const register = {
        
       init: function() {
            var country = '';
            $.getJSON("http://ip-api.com/json/?callback=?", function(data) {
                country += data.country;
                console.log("CURRENT_COUNTRY", country)
            });
  
            $("#register").on('click', function () {
                const $this = $(this);
                const $caption = $($this).html();
                const alert = $("#register-alert");
                const form = "#register-form";
                const formData = $(form).serialize();
                const route = $(form).attr('action') + '?query=createAccount';

                var html = '';

                $.ajax({
                    type: "post", //we are using GET method to get all record from the server
                    url: route, // get the route value
                    data: formData +"&from=register&country="+country+"",
            
                    beforeSend: function () {
                        console.log("Before send");
                        $this.attr('disabled', true).html("Register...");
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        console.log("RESULT_DATA", response);
                        //$this.attr('disabled', false).html($caption);
                        // Parse the json result
                        response = JSON.parse(response);
                        if(response.success) {
                            html += '<div class="alert alert-success" role="alert" data-mdb-color="success">';
                            html += response.msg;
                            html += '</div>';

                            html += '<div id="register-field" class="field-wrapper input mb-2">';
                            html += '<div class="d-sm-flex justify-content-between">';
                            html += '<div class="field-wrapper">'; // <!-- Simple link -->
                            html += '<div class="col text-center">';
                            html += 'Go to <a href="login.php">';
                            html += '<button type="submit" class="btn btn-primary btn-login" name="login" value="login">Login</button>';
                            html += '</a>';
                            html += '</div>';
                            html += '</div>';
                            html += '</div>';
                            html += '</div>';
                          
                            $(alert).html(html);
                            $(form).remove();
                        } else {
                            html += '<div class="alert alert-info" role="alert" data-mdb-color="info">';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                            
                            setTimeout(function() {
                                $this.attr('disabled', false).html($caption);
                            }, 1000)
                        }
                    },
                    error: function (error) {
                        html = '';
                        //error = JSON.parse(JSON.stringify(error));
                        console.log(error);

                        if (error != null && error.status != 'undefined') {
                            html += '<div class="alert alert-danger" role="alert" data-mdb-color="danger">';
                            html += '<strong>' + error.status + '</strong> ' + error.statusText + '';
                            html += '</div>';
                            $(alert).html(html);
                            setTimeout(function() {
                                $this.attr('disabled', false).html($caption);
                            }, 1000)
                        }
                    }
                });
            
            });
       }
    }

    return {
        initialize: function(type) {
            if(type !== undefined) {
                console.log(type)
                if(type == "login") {
                    login.init();
                } else if(type == "register") {
                    register.init();
                }
            } 
        }
    }
}();

 var Users = function() {
    var fetch = {
        init: function(level, page, perpage) {
            console.log("Ready to fetch all users");
            
            const results = $("#users-list"); // Our results DIV that will store our results
            const table = $("#users-table");
            const pagination = $("#users-pagination"); // Our pagination DIV that will store our pagination
            const loadingDiv = $("#loading-users");
            var html = '';

            getUsers(page, true);

            function getUsers(page, loading) {
                // Ajax config
                $.ajax({
                    type: "post", //we are using POST method to get all record from the server
                    url: 'server/users.db.php?query=fetchAllUsers', // get the route value
                    data: {
                        level: level,
                        page: page,
                        perpage: perpage
                    },
                    beforeSend: function () {
                        html += '<div class="container">';
                        html += '<div class="text-center">';
                        html += '<img src="assets/img/loading-hourglass.svg" at="..." style="width: 100px;height:100px;"></img>';
                        html += '<h6>Loading users...</h6>';
                        html += '</div>';
                        html += '</div>';
                        $(loadingDiv).html(html);
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here

                        // Parse the json result
                        response = JSON.parse(response);
                        //console.log(response.content);

                        const noData = response.content.includes("No user found"); // true
                        if (noData) {
                            $(loadingDiv).html(response.content);
                        } else {
                            if (loading) {
                                $(results).html(response.content);
                                //console.log("Content " + response.content);
                                $(pagination).html(response.pagination);
                                $(table).removeClass('d-none');
                            }
                            $(loadingDiv).remove();
                        }

                        $('[data-toggle="tooltip"]').tooltip({
                            placement: 'top'
                        });


                        $(".pag-link").on("click", function () {
                            let page = $(this).attr("id"); //Get ID of clicked pagination number
                            //$(list).remove();
                            getUsers(page, true); //pass the ID into our function
                            //console.log(page);    
                        });

                        //$("#users-list").html(html);
                    },
                    error: function (error) {
                        html = '';
                        error = JSON.parse(JSON.stringify(error));
                        console.log(error);

                        if (error != null && error.status != 'undefined') {
                            html += '<div class="container">';
                            html += '<div class="text-center">';
                            html += '<img src="assets/img/noun-emotion.svg" at="Error 404" style="width: 100px;height:100px;"></img>';
                            html += '<h6><strong style="color: red;">' + error.status + '</strong> ' + error.statusText + '</h6>';
                            html += '</div>';
                            html += '</div>';

                            $(loadingDiv).html(html);
                        }
                    }
                });
            }
        
            $(document).delegate("[data-target='#edit-user-modal']", "click", function () {

                var identifier = $(this).attr('data-id');
                console.log(identifier);

                // Ajax config
                $.ajax({
                    type: "GET", //we are using GET method to get data from server side
                    url: 'server/users.db.php?query=fetchUserById', // get the route value
                    data: {
                        identifier: identifier
                    }, //set data
                    beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click

                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        response = JSON.parse(response);
                        //console.log(response);
                        $("#update-user-form [name=\"identifier\"]").val(response.identifier);
                        $("#update-user-form [name=\"full_name\"]").val(response.name);
                        $("#update-user-form [name=\"email\"]").val(response.email);
                        $("#update-user-form [name=\"profile\"]").val(response.picture);

                        $("#btnUpdateUserSubmit").on("click", function() {
                            const $this = $(this);
                            const $caption = $($this).html();
                            const form = $("#update-user-form");
                            const formData = form.serialize();
                            const route = form.attr('action')+'?query=updateUserById';
                            $.ajax({
                                type: 'post',
                                url: route,
                                data: formData,
                                beforeSend: function() {
                                    console.log("Before clicked");
                                    $this.attr('disabled', true).html("Update...");
                                },
                                success: function(response) {
                                    console.log(response);
                                    $this.attr('disabled', true).html($caption);
                                    $('#edit-user-modal').modal('hide');
                                    setTimeout(function() {
                                        window.location.reload()
                                    }, 800)
                                },
                                error: function(error) {
                                    console.log(error);
                                }
                            })
                        });
                    }
                });
            });

            $(document).delegate("[data-target='#delete-user-modal']", "click", function () {
                const identifier = $(this).attr('data-id');
                console.log(identifier);

                $("#btnDeleteUserSubmit").click(function () {
                    console.log("Button delete user pressed, ID: " + identifier);

                    // Ajax config
                    $.ajax({
                        type: "post", //we are using GET method to get data from server side
                        url: 'server/users.db.php?query=deleteUserById', // get the route value
                        data: { identifier: identifier
                        }, //set data
                        dataType: 'JSON',
                        beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                            console.log("Before Send");
                        },
                        success: function (response) { //once the request successfully process to the server side it will return result here
                            //response = JSON.parse(response);
                            console.log("Result " + response);
                            if(response.success) {
                                $("#row_" + identifier).remove();
                            }
                            $('#delete-user-modal').modal('hide');
                        },
                        error: function (error) {
                            console.log("Error " + error);
                        }
                    });
                });

            });
        }
    }

    var add = {
        init: function() {
            // var country = '';
            // $.getJSON("http://ip-api.com/json/?callback=?", function(data) {
            //     country += data.country;
            // });

             console.log("Ready to submit new user");
            $("#btnAddUserSubmit").on("click", function() {
                const $this = $(this);
                const $caption = $($this).html();
                const form = $("#add-user-form");
                const alert = $("#add-user-alert");
                const formData = form.serialize();
                const route = form.attr('action') + '?query=createAccount';
                const country = "Unknown";
                var html = '';
                console.log(formData)

                $.ajax({
                    type: 'post',
                    url: route,
                    data: formData + "&from=addNewUser&country="+country+"",
                    beforeSend: function() {
                        console.log("Before clicked");
                        $this.attr('disabled', true).html("Adding...");
                    },
                    success: function(response) {
                        response = JSON.parse(response);
                        console.log(response);
                        $this.attr('disabled', false).html($caption);
                        if(response.success) {
                            html += '<div class="alert alert-success" role="alert" data-mdb-color="success">';
                            html += ' <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                            form[0].reset();
                            setTimeout(function() {
                               window.location.reload();
                            }, 500);    
                        } else {
                            html += '<div class="alert alert-warning" role="alert" data-mdb-color="warning">';
                            html += ' <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                        }
                        
                    },
                    error: function(error) {
                        console.log(error);
                    }
                })
            });
        }
    }

    return {
        getUsers: function(level, page, perpage) {
            fetch.init(level, page, perpage);
            //alert("Alert from get users function");
        },
        addUser: function() {
            //alert("Alert from add user function");
            add.init();
        },
    }
}();

const Wallpapers = function() {
    
    const fetch = {
        init: function(page, perpage) {
            var currentpage = page;
             //create function that will run automatically on page load.
             getWallpapers(page, true); //call function on page load with the default page which will be 1.

             function getWallpapers(page, loading) { //Pass in the page argument into the function. This will be the ID of the page number later
                const results = $("#pagination"); // Our results DIV that will store our results
                 const loadingDiv = $("#loading");
 
                 var html = '';
 
                 $.ajax({
                     type: 'post',
                     url: 'server/wallpapers.db.php?query=fetchAllWallpapers',
                     data: { page: page, perpage: perpage },
                     beforeSend: function () {
                         html += '<div class="container">';
                         html += '<div class="text-center">';
                         html += '<img src="assets/img/loading-hourglass.svg" at="..." style="width: 100px;height:100px;"></img>';
                         html += '<h6>Loading wallpapers...</h6>';
                         html += '</div>';
                         html += '</div>';
                         $(loadingDiv).html(html);
                     },
                     success: function (data) {
 
                         //console.log(data);
                         if (loading) {
                             $(results).html(data);
                         }
                         $(loadingDiv).remove();
 
                         $('[data-toggle="tooltip"]').tooltip({
                             placement: 'top'
                         });
 
                         $(".pag-link").on("click", function () {
                             let page = $(this).attr("id"); //Get ID of clicked pagination number
                             //$(list).remove();
                             currentpage = page;
                             getWallpapers(page, true); //pass the ID into our function
                             //console.log(page);    
                         });
                     },
                     error: function (error) {
                         //$(loadingDiv).remove();
                         html = '';
                         error = JSON.parse(JSON.stringify(error));
                         console.log(error);
 
                         if (error != null && error.status != 'undefined') {
                             html += '<div class="container">';
                             html += '<div class="text-center">';
                             html += '<img src="assets/img/noun-emotion.svg" at="Error 404" style="width: 100px;height:100px;"></img>';
                             html += '<h6><strong style="color: red;">' + error.status + '</strong> ' + error.statusText + '</h6>';
                             html += '</div>';
                             html += '</div>';
 
                             $(results).html(html); 
                         }
                     }
                 });
             };

             $("#btnSearchWallpaper").click(function () {
                const form = $("#search-form");
                const formData = form.serialize();
                const route = form.attr("action") + "?query=searchById";

                const loadingDiv = $("#loading");
                const results = $("#pagination"); // Our results DIV that will store our results
                

                var html = '';
            
                console.log("SEARCH", perpage + " : " + currentpage);
            
                // Ajax config
                $.ajax({
                    type: "POST", //we are using GET method to get data from server side
                    url: route, // get the route value
                    data: formData +"&perpage="+perpage+"&page="+page+"", //set data
                    beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                        $(results).html(html);
                        html += '<div class="container">';
                        html += '<div class="text-center">';
                        html += '<img src="assets/img/loading-hourglass.svg" at="..." style="width: 100px;height:100px;"></img>';
                        html += '<h6>Loading wallpapers...</h6>';
                        html += '</div>';
                        html += '</div>';
                        $(loadingDiv).html(html);
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        html = '';
                       
                        if(response.length) {
                            console.log("SEARCH", response);
                            $(results).html(response);

                            $(".pag-link").on("click", function () {
                                let page = $(this).attr("id"); //Get ID of clicked pagination number
                                currentpage = page;
                                getWallpapers(page, true); //pass the ID into our function  
                            });
                        } else {
                            html += '<div class="container">';
                            html += '<div class="text-center">';
                            html += '<img src="assets/img/no_photo.svg" at="..." style="width: 100px;height:100px;"></img>';
                            html += '<h6>No result</h6>';
                            html += '</div>';
                            html += '</div>';
                            $(results).html(html);
                        }

                        $('[data-toggle="tooltip"]').tooltip({
                            placement: 'top'
                        });
                    }
                });
            
             });

             $(document).delegate("[data-target='#edit-wallpaper-modal']", "click", function () {
                const identifier = $(this).attr('data-id');
                console.log(identifier);

                // Ajax config
                $.ajax({
                    type: "POST", //we are using GET method to get data from server side
                    url: 'server/wallpapers.db.php?query=fetchWallpaperById', // get the route value
                    data: { identifier: identifier }, //set data
                    beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click

                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        response = JSON.parse(response);
                        console.log(response);
                        $("#edit-wallpaper-form [name=\"identifier\"]").val(response.identifier);
                        $("#edit-wallpaper-form [name=\"wallpaper_name\"]").val(response.name);
                        $("#edit-wallpaper-form [name=\"wallpaper_url\"]").val(response.url);
                        $("#edit-wallpaper-form [id=\"wallpaper_preview\"]").attr('src', response.url);
                    }
                });


                $("#btnUpdateWallpaperSubmit").on("click", function() {
                    const $this = $(this);
                    const $caption = $($this).html();
                    const alert = $("#alert-message");
                    const form = $("#edit-wallpaper-form");
                    const formData = form.serialize();
                    const route = form.attr('action')+'?query=updateWallpaperById';
                    var html = '';

                    $.ajax({
                        type: 'post',
                        url: route,
                        data: formData,
                        beforeSend: function() {
                            console.log("Before clicked");
                            $this.attr('disabled', true).html("Update...");
                        },
                        success: function(response) {
                            response = JSON.parse(response);
                            console.log(response);
                            $this.attr('disabled', false).html($caption);

                            if(response.success) {
                                $('#edit-wallpaper-modal').modal('hide');
                                setTimeout(function() {
                                    window.location.reload()
                                }, 800)
                            } else {
                                html += '<div class="alert alert-info" role="alert" data-mdb-color="info">';
                                html += response.msg;
                                html += '</div>';
                                $(alert).html(html);
                            }                           
                        },
                        error: function(error) {
                            console.log(error);
                        }
                    })
                });

             });

             $(document).delegate("[data-target='#delete-wallpaper-modal']", "click", function () {
                const identifier = $(this).attr('data-id');
                console.log(identifier);

                $("#btnDeleteWallpaperSubmit").click(function () {
                    console.log("Button delete wallpaper pressed, ID: " + identifier);

                    // Ajax config
                    $.ajax({
                        type: "post", //we are using GET method to get data from server side
                        url: 'server/wallpapers.db.php?query=deleteWallpaperById', // get the route value
                        data: { identifier: identifier }, //set data
                        beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                            console.log("Before Send");
                        },
                        success: function (response) { //once the request successfully process to the server side it will return result here
                            response = JSON.parse(response);

                            console.log("Result " + response);
                            if(response.success) {
                                $("#row_" + identifier).remove();
                            }
                            $('#delete-wallpaper-modal').modal('hide');
                        },
                        error: function (error) {
                            console.log("Error " + error);
                        }
                    });
                });

             });             
        }
    }

    const add = {
        init: function() {
            console.log("Ready to submit wallpaper");
            $("#addwallpaper").on("click", function () {
                const $this = $(this);
                const $caption = $this.html();
                const formId = "#form-addwallpaper";
                const formDataAddWallpaper = $(formId).serializeArray();
                const route = $(formId).attr('action') + '?query=addwallpaper';

                var html = '';
                // Ajax config
                $.ajax({
                    type: "POST", //we are using GET method to get data from server side
                    url: route, // get the route value
                    data: formDataAddWallpaper, //set data
                    beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                        $this.attr('disabled', true).html("Processing...");
                    },
                    success: function (response) { //once the request successfully process to the server side it will return result here
                        $this.attr('disabled', false).html($caption);
                        response = JSON.parse(response);

                        if (response.success) {
                            html += '<div class="alert alert-success" role="alert" data-mdb-color="success">';
                            html += '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(formId)[0].reset();
                            window.setTimeout(function () {
                                $("#alert-message").fadeTo(500, 0).slideUp(500, function () {
                                    $(this).remove();
                                    //window.location.reload();
                                });
                            }, 2000);
                        } else {
                            html += '<div class="alert alert-info" role="alert" data-mdb-color="info">';
                            html += '<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                        }
                        $("#alert-message").html(html);
                        console.log(response);
                    }
                });
            })
        }
    }

    const publishers = {
        init: function() {
            const results = $("#publisher_id");
            var html = '';
            $.ajax({
                type: 'post',
                url: 'server/wallpapers.db.php?query=fetchUsers',
                dataType: 'JSON',
                success: function(response) {
                    console.log("DATA_LENGTH", response.length);
                    if(response.length) {
                        html += '<option value="">--Select User--</option>';
                        $.each(response, function(key,value) {
                            var name = value.name == '' ? value.username : value.name
                            html += '<option value="'+ value.identifier +'">'+ name +'</option>';
                        })
                        $(results).html(html);
                    }
                },
                error: function(error) {
                    console.log("ERROR", error);
                }
            }) 
        }
    }

    return {
        getWallpapers: function(page, perpage) {
            fetch.init(page, perpage);
        },
        addWallpaper: function() {
            publishers.init();
            add.init();
            //alert("Alert from add wallpaper function");
        }
    }
}();

const Statistics = function() {

    const instance = {
        init: function() {
            const results = $("#result-statistics"); // Our results DIV that will store our results
            const loadingDiv = $("#loading-statistics");

            var html = '';

            $.ajax({
                type: 'post',
                url: 'server/statistics.db.php?query=statistics',
                data: 0,
                beforeSend: function () {
                    html += '<div class="container">';
                    html += '<div class="text-center">';
                    html += '<img src="assets/img/loading-bar-chart.svg" at="..." style="width: 100px;height:100px;"></img>';
                    html += '<h6>Loading...</h6>';
                    html += '</div>';
                    html += '</div>';
                    $(results).html(html);
                },
                success: function (data) {
                    //console.log(data);
                    //html = '';
                    //$(results).html(html);
                    $(results).html(data);
                    //$(loadingDiv).remove();

                    $('[data-toggle="tooltip"]').tooltip({
                        placement: 'top'
                    });
                },
                error: function (error) {
                    html = '';
                    error = JSON.parse(JSON.stringify(error));
                    console.log(error);

                    if (error != null && error.status != 'undefined') {
                        html += '<div class="container">';
                        html += '<div class="text-center">';
                        html += '<img src="assets/img/noun-emotion.svg" at="Error 404" style="width: 100px;height:100px;"></img>';
                        html += '<h6><strong style="color: red;">' + error.status + '</strong> ' + error.statusText + '</h6>';
                        html += '</div>';
                        html += '</div>';

                        $(results).html(html);
                    }
                }
            });
        }
    }

    return {
        initialize: function() {
            instance.init();
        }
    }
}();

const Settings = function() {

    const monetization = {
        init: function() {
            const adNetworkSelect = $("#monetization-form #ad_network")
            const admob = $("#monetization-form #admob-units")
            const unity = $("#monetization-form #unity-units")

             // Ajax config
             $.ajax({
                type: "post", //we are using GET method to get data from server side
                url: 'server/monetization.db.php?query=fetchMonetization', // get the route value
                dataType: 'JSON', //set data
                beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                    console.log("Fetch_Monetization", "sending...");
                },
                success: function (response) { //once the request successfully process to the server side it will return result here
                    //response = JSON.parse(response);
                    console.log("Fetch_Monetization", response.ad_enabled_status);

                    const statusValue = response.ad_enabled_status == 1 ? "on" : "off" 
                    const status_color = statusValue == "on" ? "#73EA00" : "#F2F2F2"
                
                    $(".circleIcon").css({"fill": status_color});

                    $("#monetization-form [name=\"ad_enabled_status\"]").val(statusValue);

                    $("#monetization-form [name=\"ad_network\"]").val(response.ad_network);
                    $("#monetization-form [name=\"admob_banner_unit_id\"]").val(response.admob_banner_unit_id);
                    $("#monetization-form [name=\"admob_native_unit_id\"]").val(response.admob_native_unit_id);
                    $("#monetization-form [name=\"admob_interstitial_unit_id\"]").val(response.admob_interstitial_unit_id);
                    $("#monetization-form [name=\"admob_rewarded_unit_id\"]").val(response.admob_rewarded_unit_id);
                    $("#monetization-form [name=\"admob_app_open_unit_id\"]").val(response.admob_app_open_unit_id);

                    $("#monetization-form [name=\"unity_game_id\"]").val(response.unity_game_id);
                    $("#monetization-form [name=\"unity_banner_unit_id\"]").val(response.unity_banner_unit_id);
                    $("#monetization-form [name=\"unity_interstitial_unit_id\"]").val(response.unity_interstitial_unit_id);
                    $("#monetization-form [name=\"unity_rewarded_unit_id\"]").val(response.unity_rewarded_unit_id);
                    $("#monetization-form [name=\"interstitial_ad_interval\"]").val(response.interstitial_ad_interval);
                    $("#monetization-form [name=\"scrolling_ad_interval\"]").val(response.scrolling_ad_interval);
                    

                    if(response.ad_network == "admob") {
                        admob.removeClass("d-none");
                        unity.addClass("d-none");
                    } else if(response.ad_network == "unity") {
                        unity.removeClass("d-none");
                        admob.addClass("d-none");
                    }
                }
            });

            adNetworkSelect.on('change', function() {
                console.log("Ad Network selected is ", this.value);
                //monetization.init()
                if(this.value == "admob") {
                    admob.removeClass("d-none");
                    unity.addClass("d-none");
                } else if(this.value == "unity") {
                    unity.removeClass("d-none");
                    admob.addClass("d-none");
                }
              });

            $("#monetization_update").on("click", function() {
                const $this = $(this);
                const $caption = $($this).html();
                const alert = $("#monetization-alert");
                const form = $("#monetization-form");
                const formData = form.serialize();
                const route = form.attr('action')+'?query=updateMonetization';
                var html = '';
                
                $.ajax({
                    type: 'POST',
                    url: route,
                    data: formData,
                    beforeSend: function() {
                        console.log("Before clicked");
                        $this.attr('disabled', true).html("Updating...");
                    },
                    success: function(response) {
                        response = JSON.parse(response);
                        console.log("Update", response);
                        $this.attr('disabled', false).html($caption);

                        if(!response.success) {
                            html += '<div class="alert alert-warning" role="alert" data-mdb-color="warning">';
                            html += ' <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                        } else  {
                            setTimeout(function() {
                                window.location.reload();
                             }, 150); 
                        }
                       
                    },
                    error: function(error) {
                        console.log("Error", error);
                    }
                })
            });
        }
    }

    const firebase = {
        init: function() {
             // Ajax config
             $.ajax({
                type: "post", //we are using GET method to get data from server side
                url: 'server/fcm.db.php?query=fetchFCMKey', // get the route value
                dataType: 'JSON', //set data
                beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click

                },
                success: function (response) { //once the request successfully process to the server side it will return result here
                    //response = JSON.parse(response);
                    //console.log("Fetch", response);
                    $("#fcm_push_form [name=\"fcm_server_key\"]").val(response.server_key);
                }
            });

            $("#fcm_push_update").on("click", function() {
                const $this = $(this);
                const $caption = $($this).html();
                const alert = $("#fcm-alert");
                const form = $("#fcm_push_form");
                const formData = form.serialize();
                const route = form.attr('action')+'?query=updateFCMKey';
                var html = '';
                
                $.ajax({
                    type: 'POST',
                    url: route,
                    data: formData,
                    beforeSend: function() {
                        console.log("Before clicked");
                        $this.attr('disabled', true).html("Updating...");
                    },
                    success: function(response) {
                        response = JSON.parse(response);
                        console.log("Update", response);
                        $this.attr('disabled', false).html($caption);

                        if(!response.success) {
                            html += '<div class="alert alert-warning" role="alert" data-mdb-color="warning">';
                            html += ' <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                            
                        }
                    },
                    error: function(error) {
                        console.log("Error", error);
                    }
                })
            });
        }
    }

    const privacy = {
        init: function() {
            // Ajax config
            $.ajax({
                type: "get", //we are using GET method to get data from server side
                url: 'server/condition.db.php?query=fetchPrivacyCondition', // get the route value
                dataType: 'JSON', //set data
                beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click

                },
                success: function (response) { //once the request successfully process to the server side it will return result here
                    //response = JSON.parse(response);
                    //console.log("Fetch", response.text);
                    console.log("PRIVACY_FETCH_CONTENT", response);
                     setTimeout(function() {
                         CKEDITOR.instances.app_privacy_policy.setData(response.text);   
                     }, 400); 
                },
                error: function(error) {
                    console.log("Error", error);
                }
            });

            $("#privacy-update").on("click", function() {
                const $this = $(this);
                const $caption = $($this).html();
                const form = $("#privacy_form");
                const formData = form.serialize();
                const route = form.attr('action')+'?query=updatePrivacyCondition';
                const content = CKEDITOR.instances['app_privacy_policy'].getData();

                console.log("PRIVACY_EDITOR_CONTENT", content);
                
                $.ajax({
                    type: 'POST',
                    url: route,
                    data: { app_privacy_policy: content },
                    beforeSend: function() {
                        console.log("Before clicked");
                        $this.attr('disabled', true).html("Updating...");
                    },
                    success: function(response) {
                        //response = JSON.parse(response);
                        console.log("Update", response);
                        $this.attr('disabled', false).html($caption);
                        CKEDITOR.instances.app_privacy_policy.checkDirty();
                        
                        window.location.reload();
                    },
                    error: function(error) {
                        console.log("Error", error);
                    }
                })
            });
        }
    }
    
    const token = {
        init: function() {
            console.log("Hash_Validator", "init...");
             // Ajax config
             $.ajax({
                type: "post", //we are using GET method to get data from server side
                url: 'server/tokens.db.php?query=fetchToken', // get the route value
                dataType: 'JSON', //set data
                beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                    console.log("Hash_Validator", "Sending...");
                },
                success: function (response) { //once the request successfully process to the server side it will return result here
                    //response = JSON.parse(response);
                    console.log("Hash_Validator", response);
                   
                    var html = '';

                    if(response.success) {
                        html += '<div class="clipboard copy-txt">';
                        html += '<p class="mb-4"><!-- Token -&gt; --> API Server Token : <span id="api-token">' +response.token+ '</span></p>';
                        html += '<div class="row token" style="margin-left:1px;">';
                        html += '<a class="mb-1 btn btn-primary" href="javascript:;" data-clipboard-action="copy" data-clipboard-target="#api-token">';
                        html += Icons.copy() + ' Copy token </a><br>';
                        html += '<a class="mb-1 btn btn-danger" href="javascript:;" data-toggle="modal" data-target="#delete-token-modal" id="delete-token">';
                        html += Icons.trash() + '  Delete </a>';
                        html += '</div>';
                        html += '</div>'; 
                    } else {
                        html += "No token found, Click Generate new token";
                    }
                    $("#access-token-result").html(html)
                },
                error: function(error) {
                    console.log("Error", error);
                }
            });

            $("#generate-token").on("click", function() {
                const $this = $(this);
                const $caption = $($this).html();
                const alert = $("#token-alert");
                var html = '';
                          
                $.ajax({
                    type: 'POST',
                    url: 'server/tokens.db.php?query=generateToken',
                    dataType: 'JSON',
                    beforeSend: function() {
                        console.log("Before clicked");
                        $this.attr('disabled', true).html("Generating...");
                    },
                    success: function(response) {
                        //response = JSON.parse(response);
                        console.log("Generate_Token", response);
                        $this.attr('disabled', false).html($caption);

                        if(response.success) {
                            html += '<div class="clipboard copy-txt">';
                            html += '<p class="mb-4"><!-- Token -&gt; --> API Server Token : <span id="api-token">' +response.token+ '</span></p>';
                            html += '<div class="row token" style="margin-left:1px;">';
                            html += '<a class="mb-1 btn btn-primary" href="javascript:;" data-clipboard-action="copy" data-clipboard-target="#api-token">';
                            html += Icons.copy() + ' Copy token </a><br>';
                            html += '<a class="mb-1 btn btn-danger" href="javascript:;" data-toggle="modal" data-target="#delete-token-modal" id="delete-token">';
                            html += Icons.trash() + '  Delete </a>';
                            html += '</div>';
                            html += '</div>'; 
                            $("#access-token-result").html(html)
                        } else {
                            html += '<div class="alert alert-warning" role="alert" data-mdb-color="warning">';
                            html += ' <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
                            html += response.msg;
                            html += '</div>';
                            $(alert).html(html);
                        }
                    },
                    error: function(error) {
                        console.log("Error", error);
                        $this.attr('disabled', false).html($caption);
                    }
                })
            });

            $(document).delegate("[data-target='#delete-token-modal']", "click", function () {
                const token = $("#api-token").html();
                console.log("ACCESS_TOKEN: ", token);

                $("#btnDeleteTokenSubmit").click(function () {
                    console.log("Button delete token pressed, ID: " + token);
                    // Ajax config
                    $.ajax({
                        type: "post", //we are using post method to get data from server side
                        url: 'server/tokens.db.php?query=deleteToken', // get the route value
                        dataType: 'JSON',
                        data: { token: token },
                        beforeSend: function () { //We add this before send to disable the button once we submit it so that we prevent the multiple click
                            console.log("Before Send");
                        },
                        success: function (response) { //once the request successfully process to the server side it will return result here
                            //response = JSON.parse(response);
                            console.log("Result " + response);
                            if(response.success) {
                                $("#access-token-result").html('')
                                $("#access-token-result").html('No token found, Click Generate new token')
                            }
                            $('#delete-token-modal').modal('hide');
                        },
                        error: function (error) {
                            console.log("Error " + error);
                        }
                    });
                });

            });
        }
    }

    return {
        initialize: function() {
            token.init();
            firebase.init();
           
            privacy.init();
            monetization.init();
        }
    }
}();

const SearchWallpaper = function() {

    return {
        init: function() {
            console.log('Searching...')
        }
    }
}();