<?php
//require __DIR__ . '/src/libs/variables.php';
//require __DIR__ . '/server/auth.php';
session_start();

include_once('config.php');
require_once LIBSDIR .'/variables.php';
require_once SERVERDIR .'/auth.php';

redirectIfUserLogedIn();
?>

<!doctype html>
<html class="no-js " lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="icon" href="assets/img/app_icon.png" sizes="32x32">
    <link rel="icon" href="assets/img/app_icon.png" sizes="192x192">
    <link rel="apple-touch-icon-precomposed" href="assets/img/app_icon.png">
    <meta name="msapplication-TileImage" content="assets/img/app_icon.png">
    <title>Wallpaper ~ Login </title>

    <link href="https://fonts.googleapis.com/css?family=Nunito:400,600,700" rel="stylesheet">
    <link href="assets/css/font-awesome.css" rel="stylesheet" type="text/css" />
    <link href="assets/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
    
    <link href="assets/css/main.css" rel="stylesheet" type="text/css" />
    <link href="assets/css/structure.css" rel="stylesheet" type="text/css" />

    <!-- END GLOBAL MANDATORY STYLES -->
    <link rel="stylesheet" type="text/css" href="assets/css/forms/theme-checkbox-radio.css">
    <link rel="stylesheet" type="text/css" href="assets/css/forms/switches.css">
    <link rel="stylesheet" type="text/css" href="assets/css/elements/alert.css">

    <link href="assets/css/authentication.css" rel="stylesheet" type="text/css" />

</head>

<body class="form">
    <div class="form-container outer bg-image shadow-2-strong">
     <div class="mask d-flex align-items-center h-100" style="background-color: rgba(0, 0, 0, 0.8);">
        <div class="form-form">
            <div class="form-form-wrap">
                <div class="form-container">
                    <div class="form-content">

                        <h1 class="">Sign In</h1>
                        <p class="">Log in to your account to continue.</p>

                        <div id="login-alert"></div>
                    
                        <!-- </?php $_SERVER['PHP_SELF']; ?> -->
                        <form action="server/login.db.php" method="post" accept-charset="utf-8" class="text-left" target="_self" id="login-form">
                            <div class="form">
                                
                                <div id="username-field" class="field-wrapper input">
                                    <label for="username">USERNAME</label>
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-user"><path d="M20 21v-2a4 4 0 0 0-4-4H8a4 4 0 0 0-4 4v2"></path><circle cx="12" cy="7" r="4"></circle></svg>
                                    <input id="username" name="username" type="text" value="" class="form-control" placeholder="User name" aria-describedby="basic-addon1" required>
                                </div>
                                

                                <div id="password-field" class="field-wrapper input mb-2">
                                    <div class="d-flex justify-content-between">
                                        <label for="password">PASSWORD</label>
                                    </div>
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-lock"><rect x="3" y="11" width="18" height="11" rx="2" ry="2"></rect><path d="M7 11V7a5 5 0 0 1 10 0v4"></path></svg>
                                    <input id="password" name="password" type="password" value="" class="form-control" placeholder="Password" aria-describedby="basic-addon2" required>
                                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" id="toggle-password" class="feather feather-eye"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                                </div>

                                <div class="row">
                                <div class="col-6 text-left">
                                    <label class="custom-control custom-checkbox custom-control-inline">
                                        <input type="checkbox" name="remember_me" checked="" class="custom-control-input"><span class="custom-control-label">Remember me</span>
                                    </label>                  
                                </div>
                                <div class="col-6 text-right">
                                    <a href="auth_pass_recovery.php" class="text-primary">forgot password?</a>
                                </div>
                                </div>
                
                                <div class="d-sm-flex justify-content-between">
                                    <div class="field-wrapper">
                                        <button type="submit" class="btn btn-primary btn-login" id="login" name="login" value="login">Log In</button>
                                    </div>
                                </div>

                                 <div id="register-field" class="field-wrapper input mb-2">
                                    <div class="d-sm-flex justify-content-between">
                                        <div class="field-wrapper">
                                            <div class="col text-center">
                                            <!-- Simple link -->
                                                Not registered? <a href="register.php">Create Account?</a>
                                            </div>
                                        </div>
                                    </div>
                                 </div>
                                
                            </div>
                        </form>
                        <p class="signup-link">© 2022 All Rights Reserved. <a href="#">Itsmed</a>.</p>
                    </div>    

                </div>
            </div>
        </div>
      </div>
    </div>
<!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
<script src="assets/js/libs/jquery-3.1.1.min.js"></script>
<script src="assets/bootstrap/js/popper.min.js"></script>
<script src="assets/bootstrap/js/bootstrap.min.js"></script>

<!-- END GLOBAL MANDATORY SCRIPTS -->
<script src="assets/js/authentication.js"></script>
<script src="assets/js/api.js"></script>

<script>
    $(document).ready(function() {
        Authentication.initialize("login");
    });
</script>

</body>
</html>