<?php
header("Content-type: application/json; charset=utf-8");

include_once('../../../config.php');
$pdo = require_once  SERVERDIR .'/database.php';
require_once LIBSDIR .'/variables.php';
require_once SERVERDIR .'/auth.php';

const MESSAGES = [
    'SEND_REPORT_FAILED' => 'Cannot Send Message: This Message Could not be Sent .',
    'SEND_REPORT_SUCCESS' => 'Your report has been successfully sent. We will contact you very soon!.',
    'SEND_FEEDBACK_SUCCESS' => 'Your feedback has been successfully sent. We will contact you very soon!.',
    'UPDATE_VIEWS_SUCCESS' => '$v count',
    'UPDATE_VIEWS_FAILED' => 'Set $v fail.',
];

if(isGetRequest()) {
    //echo "Request from get query";
    //return;
    if(isset($_GET['token']) && !empty($_GET['token'])) {
        $validator = string_strip(['GET' => 'token']);
        if(checkValidatorToken()) {
            if(isset($_GET['fetch']) && !empty($_GET['fetch'])) {
                switch(strtolower($_GET['fetch'])) {
                    case 'all':
                        if(isset($_GET['page'], $_GET['perpage']) && 
                            !empty($_GET['page']) && !empty($_GET['perpage']) ) {
                                $publisherId = empty($_GET['publisher']) ? '' : string_strip(['GET' => 'publisher']);
                                $page = string_strip(['get' => 'page']);
                                $perpage = string_strip(['GET' => 'perpage']);
                                $sort = string_strip(['GET' => 'sort']);
                                $searchKeyword = empty($_GET['keyword']) ? '' : string_strip(['GET' => 'keyword']);
                              
                                getReadMoreWallpapers();
                        } else {
                            //print unknownError();
                            print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query one or more parameters is required on GET.'), JSON_PRETTY_PRINT);
                        }
                        break;
                    case 'publisher':
                          if(isset($_GET['publisher']) && !empty($_GET['publisher'])) {
                            $publisherId = string_strip(['GET' => 'publisher']);
                            getPublisher();
                          } else {
                             print unknownError();
                          }
                        break;
                    case 'settings':
                        getSettings();
                        break;
                    default: {
                        print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query parameter "'.strtolower($_GET['fetch']).'" invalid on GET.'), JSON_PRETTY_PRINT);
                    }
                }
            } else {
                print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query parameter "fetch" is required on GET.'), JSON_PRETTY_PRINT);
            }
        } else {
            print json_encode(array('code' => 'InvalidTokenValidator', 'error' => 'There was an error in evaluating the Pre-request undefined access-token is empty or expired.'), JSON_PRETTY_PRINT);
        }
    } else {
        print json_encode(array('code' => 'ParamTokenRequiredError', 'error' => 'Query parameter "token" is required on GET.'), JSON_PRETTY_PRINT);
    }
}

if(isPostRequest()) {
    if(isset($_POST['token']) && !empty($_POST['token'])) {
        $validator = string_strip(['POST' => 'token']);
        if(checkValidatorToken()) {
            if(isset($_POST['requestType']) && !empty($_POST['requestType'])) {
                switch($_POST['requestType']) {
                    case 'report':
                        if(isset($_POST['reportId'], $_POST['name'], $_POST['subject'], $_POST['email'], $_POST['wallpaperId'], $_POST['wallpaperUrl']) && 
                            !empty($_POST['reportId']) && !empty($_POST['name']) && !empty($_POST['subject']) && !empty($_POST['email']) &&  !empty($_POST['wallpaperId']) && !empty($_POST['wallpaperUrl'])) {
                                
                                $reportId = string_strip(['POST' => 'reportId']);
                                $reportSubject = string_strip(['POST' => 'subject']);
                                $reportName = isset($_POST['name']) ? string_strip(['POST' => 'name']) : '';
                                $reportEmail = string_strip(['POST' => 'email']);
                                $reportMessage = isset($_POST['report']) ? string_strip(['POST' => 'report']) : '';
                                $reportWallpaperId = isset($_POST['wallpaperId']) ? string_strip(['POST' => 'wallpaperId']) : 908;
                                $reportWallpaperUrl = string_strip(['POST' => 'wallpaperUrl']);
                                
                                sendReport();
                            return;
                        } 
                        break;
                    case 'feedback':
                        //print json_encode(array('code' => 'ParamsRequiredError', 'error' => 'All data params required. '.$_POST['report']), JSON_PRETTY_PRINT);
                         if(isset($_POST['subject'], $_POST['name'], $_POST['email'], $_POST['feedback']) && 
                            !empty($_POST['subject']) && !empty($_POST['name']) && !empty($_POST['email']) && !empty($_POST['feedback']) ) {
                                $feedbackSystemName = string_strip(['POST' => 'system_name']);
                                $feedbackSystemVersion = string_strip(['POST' => 'system_version']);
                                $feedbackModelName = string_strip(['POST' => 'model_name']);
                                $feedbackLocalized = string_strip(['POST' => 'localized']);
            
                                $feedbackSubject = string_strip(['POST' => 'subject']);
                                $feedbackName = isset($_POST['name']) ? string_strip(['POST' => 'name']) : '';
                                $feedbackEmail = string_strip(['POST' => 'email']);
                                $feedbackMessage = isset($_POST['feedback']) ? string_strip(['POST' => 'feedback']) : '';
                                sendFeedback();
                               // print json_encode(array("success" => true, "msg" => "Message here"), JSON_PRETTY_PRINT);
                            return;
                        } else {
                            print json_encode(array('code' => 'ParamsRequiredError', 'error' => 'All data params required.'), JSON_PRETTY_PRINT);
                        }
                        break;
                    case 'views':
                         if(isset($_POST['wallpaperId']) && !empty($_POST['wallpaperId'])) {
                            $wallpaperId = string_strip(['POST' => 'wallpaperId']);
                            updateViewsOrDownloadsWallpaper($_POST['requestType']);      
                         } else {
                            print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query parameter "views" invalid on post.'), JSON_PRETTY_PRINT);
                         }
                        break;
                    case 'downloads':
                        if(isset($_POST['wallpaperId']) && !empty($_POST['wallpaperId'])) {
                            $wallpaperId = string_strip(['POST' => 'wallpaperId']);
                            updateViewsOrDownloadsWallpaper($_POST['requestType']);      
                        } else {
                            print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query parameter "downloads" invalid on post.'), JSON_PRETTY_PRINT);
                        }
                        break;
                    default:
                     print json_encode(array('code' => 'ParamRequiredError', 'error' => 'Query one or more parameter invalid on post.'), JSON_PRETTY_PRINT);
                    break;
                }
            }
        } else {
            print json_encode(array('code' => 'InvalidTokenValidator', 'error' => 'There was an error in evaluating the Pre-request undefined access-token is empty or expired.'), JSON_PRETTY_PRINT);
        }
    } else {
        print json_encode(array('code' => 'ParamTokenRequiredError', 'error' => 'Data Parameter "token" is required on POST.'), JSON_PRETTY_PRINT);
    }  
}

function getSettings() {
    $settingsMonetization = getMonetization();
    if($settingsMonetization) {
        print json_encode(
            array(
                'adEnabledStatus' => (bool) $settingsMonetization['ad_enabled_status'] == 1 ? true : false,
                'adNetwork' => (string) $settingsMonetization['ad_network'],

                // Admob
                'admobBannerUnitId' => (string) $settingsMonetization['admob_banner_unit_id'],
                'admobNativeUnitId' => (string) $settingsMonetization['admob_native_unit_id'],
                'admobInterstitialUnitId' => (string) $settingsMonetization['admob_interstitial_unit_id'],
                'admobRewardedUnitId' => (string) $settingsMonetization['admob_rewarded_unit_id'],
                'admobAppOpenUnitId' => (string) $settingsMonetization['admob_app_open_unit_id'],

                // Unity
                'unityGameId' => (string) $settingsMonetization['unity_game_id'],
                'unityBannerUnitId' => (string) $settingsMonetization['unity_banner_unit_id'],
                'unityInterstitialUnitId' => (string) $settingsMonetization['unity_interstitial_unit_id'],
                'unityRewardedUnitId' => (string) $settingsMonetization['unity_rewarded_unit_id'],
                'adInterstitialInterval' => (int) $settingsMonetization['interstitial_ad_interval'],
                'adScrollingInterval' => (int) $settingsMonetization['scrolling_ad_interval'],
                
            ), 
            JSON_PRETTY_PRINT);
    } else {
        print json_encode(array('code' => 'InvalidDatabase', 'error' => 'There was an error in database.'), JSON_PRETTY_PRINT);
    }
}

function getPublisher() {
    $publisherInfo = getPublisherInfo();
    if($publisherInfo) {
        print json_encode(
            array(
                'id' => (int) $publisherInfo['id'],
                'name' => (string) $publisherInfo['name'],
                'username' => (string) $publisherInfo['username'],
                'email' => (string) $publisherInfo['email'],
                //'identifier' => (string) $publisherInfo['identifier'],
                'picture' => (string) $publisherInfo['picture'],
                'gender' => (string) $publisherInfo['gender'],
                'country' => (string) $publisherInfo['country'],
                'role' => (string) $publisherInfo['level'] == 1 ? 'Admin' : 'Editor',
            ), 
            JSON_PRETTY_PRINT);
    } else {
        print json_encode(array('code' => 'InvalidDatabase', 'error' => 'There was an error in database.'), JSON_PRETTY_PRINT);
    }
}

function getReadMoreWallpapers() {
    global $pdo, $page, $perpage, $sort, $publisherId, $searchKeyword;

    $order = '';
    switch($sort) {
        case 'random':
            $order = 'ORDER BY RAND()';
            break;
        case 'desc':
            $order = 'ORDER BY `id` DESC';
            break;
        case 'asc':
            $order = 'ORDER BY `id` ASC';
            break;
        case 'views':
            $order = 'ORDER BY `views` DESC';
            break;
        case 'downloads':
            $order = 'ORDER BY `downloads` DESC';
            break;
        case 'lastweek':
            $order = 'WHERE `created_at`=CURDATE()-INTERVAL 6 DAY';
            break;
        default:
            $order = 'ORDER BY RAND()';
            break;
    }
    if($publisherId != null) {
        $order = 'WHERE `publisher_id` = '.$publisherId .= ' ' .$order;
    }
    if ($searchKeyword != null && $publisherId != null) {
        $order .= " AND name LIKE '%$searchKeyword%'";
    } else if ($searchKeyword != null && $publisherId == null) {
        $order = "WHERE name LIKE '%$searchKeyword%' " . $order;
    }
    
    $start = ($page -1) * $perpage;
    $rowCount = numOfRows();

    $query = "SELECT * FROM `tb_images` $order LIMIT " .$start. "," . $perpage ;
    
    $stmt = $pdo->prepare($query);
    $stmt->execute();
    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $stmt->closeCursor();

    $wallpapersArray = array();
    $jsonArray = array();

    // Records
    if($rowCount) {
        // Content
        foreach($rows as $wallpaper) {
            array_push($wallpapersArray, array(
                'id' => (int) $wallpaper['id'],
                'name' => (string) $wallpaper['name'],
                'url' => (string) $wallpaper['url'],
                'identifier' => (string) $wallpaper['identifier'],
                'views' => (int) $wallpaper['views'],
                'downloads' => (int) $wallpaper['downloads'],
                'publisherId' => (string) $wallpaper['publisher_id'],
                'publisherName' => (string) $wallpaper['publisher_name'] ? $wallpaper['publisher_name'] : "Unknown",
                'createdAt' => (string) $wallpaper['created_at']
            ));  
        }

        array_push($jsonArray, array('images' => $wallpapersArray));

    } else {
        //$html .= noWallpapers();
    }
    $pages = ceil($rowCount / $perpage);
    $hasMore = $page < $pages;
    print json_encode(
        array(
            'perPage' => (int) $perpage,
            'pages' => (int) $pages,
            'currentPage' => (int) $page,
            'resultPage' => $page. ' of ' .$pages, 
            'totalItems' => (int) $rowCount,
            'hasMore' => (bool) $hasMore, 
            'images' => (array) $wallpapersArray
        ), 
        JSON_PRETTY_PRINT);
}

function reportCount() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_reports`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
}

function getPublisherInfo() {
    global $pdo, $publisherId;
    $sql = "SELECT * FROM `tb_users` WHERE identifier = :ID "; 
    $stmt = $pdo->prepare($sql);
    $stmt->bindValue(':ID', $publisherId, PDO::PARAM_STR);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function getMonetization() {
    global $pdo;
    $sql = "SELECT * FROM `tb_monetization`"; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function noWallpapers() {
    return '';
}

function unknownError() {
    return '';
}

function numOfRows() {
    global $pdo, $publisherId, $isSearch, $searchKeyword;

    if($publisherId != null && $searchKeyword != null) {
        $where = "WHERE publisher_id =" .$publisherId. " AND name LIKE '%$searchKeyword'";
    } else if ($publisherId){
        $where = "WHERE publisher_id =" .$publisherId. "";
    } else if($isSearch == true) {
        $where = "WHERE name LIKE '%$searchKeyword%'";
    } else {
        $where = "";
    }
    $sql = 'SELECT COUNT(*) FROM `tb_images` ' . $where; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetchColumn();
    $stmt->closeCursor();
    return $row;
}

function checkValidatorToken() {
    global $pdo, $validator;
    $sql = 'SELECT COUNT(*) FROM `tb_tokens` WHERE hashed_validator = :validator'; 
    $stmt = $pdo->prepare($sql);
    $stmt->bindValue(':validator', $validator, PDO::PARAM_STR);
    $stmt->execute();
    $row = $stmt->fetchColumn();
    $stmt->closeCursor();
    return $row ? true : false;
}

function sendReport() {
    global $pdo, $reportId, $reportSubject, $reportWallpaperId, $reportWallpaperUrl, $reportName, $reportEmail, $reportMessage, $msg;
    $stmt = $pdo->prepare("INSERT INTO `tb_reports` (`ticket_id`, `subject`, `wallpaper_id`, `wallpaper_url`, `name`, `email`, `report`, `created_at`)
                          VALUES( :ticketid, :subject, :wallpaperid, :wallpaperurl, :name, :email, :report, :date ) ");
    $stmt->bindValue(':ticketid', (int) $reportId, PDO::PARAM_INT);
    $stmt->bindValue(':wallpaperid', (int)$reportWallpaperId, PDO::PARAM_INT);
    $stmt->bindValue(':wallpaperurl', $reportWallpaperUrl, PDO::PARAM_STR);
    $stmt->bindValue(':subject', $reportSubject, PDO::PARAM_STR);
    $stmt->bindValue(':name', $reportName, PDO::PARAM_STR);
    $stmt->bindValue(':email', $reportEmail, PDO::PARAM_STR);
    $stmt->bindValue(':report', $reportMessage, PDO::PARAM_STR);
    $stmt->bindValue(':date', date("Y-m-d H:i:s"));
    $resultSet = $stmt->execute();
    $resultSet ? $msg = MESSAGES['SEND_REPORT_SUCCESS'] : $msg = MESSAGES['SEND_REPORT_FAILED'];
    print json_encode(array("success" => $resultSet, "msg" => $msg), JSON_PRETTY_PRINT);
}

function sendFeedback() {
    global $pdo, $feedbackSystemName, $feedbackSystemVersion,$feedbackModelName,$feedbackLocalized,$feedbackSubject, $feedbackName, $feedbackEmail, $feedbackMessage, $msg;
    $stmt = $pdo->prepare("INSERT INTO `tb_feedback` (`system_name`, `system_version`, `model_name`, `localized`, `subject`, `name`, `email`, `message`, `created_at`)
                          VALUES(:system,:version,:model,:localized,:subject,:name,:email,:message,:date) ");
    $stmt->bindValue(':system', $feedbackSystemName, PDO::PARAM_STR);
    $stmt->bindValue(':version', (float) $feedbackSystemVersion);
    $stmt->bindValue(':model', $feedbackModelName, PDO::PARAM_STR);
    $stmt->bindValue(':localized', $feedbackLocalized, PDO::PARAM_STR);
    $stmt->bindValue(':subject', $feedbackSubject, PDO::PARAM_STR);
    $stmt->bindValue(':name', $feedbackName, PDO::PARAM_STR);
    $stmt->bindValue(':email', $feedbackEmail, PDO::PARAM_STR);
    $stmt->bindValue(':message', $feedbackMessage, PDO::PARAM_STR);
    $stmt->bindValue(':date', date("Y-m-d H:i:s"));
    $resultSet = $stmt->execute();
    $resultSet ? $msg = MESSAGES['SEND_FEEDBACK_SUCCESS'] : $msg = MESSAGES['SEND_REPORT_FAILED'];
    print json_encode(array("success" => $resultSet, "msg" => $msg), JSON_PRETTY_PRINT);
}

function updateViewsOrDownloadsWallpaper($type) {
    global $pdo, $count, $wallpaperId, $msg;
    switch($type) {
        case "views":
            $conditionKey = 'views';
            break;
        case "downloads":
            $conditionKey = 'downloads';
            break;
        default: return;
    }

    $count = getWallpaperByID()[''.$conditionKey.''] + 1;
    
    if($count) {
        $stmt = $pdo->prepare("UPDATE `tb_images` SET $conditionKey=:value WHERE identifier = :wallID");
        $stmt->bindValue(':value', (int) $count, PDO::PARAM_STR);
        $stmt->bindValue(':wallID', $wallpaperId, PDO::PARAM_STR);
        $resultSet = $stmt->execute();
        $resultSet ? $msg = str_replace('$v', $count . ' ' . $conditionKey, MESSAGES['UPDATE_VIEWS_SUCCESS']) : $msg = str_replace('$v', $conditionKey,  MESSAGES['UPDATE_VIEWS_FAILED']);
    } else {
        $resultSet = false;
        $msg = str_replace('$v', $conditionKey,  MESSAGES['UPDATE_VIEWS_FAILED']);
    }
    print json_encode(array("success" => $resultSet, "msg" => $msg), JSON_PRETTY_PRINT);
}

function getWallpaperByID() {
    global $pdo, $wallpaperId;
    $sql = 'SELECT * FROM `tb_images` WHERE identifier = :wallID'; 
    $stmt = $pdo->prepare($sql);
    $stmt->bindValue(':wallID', $wallpaperId, PDO::PARAM_STR);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function getAllWallpapers() {
    global $pdo;
    $sql = 'SELECT * FROM `tb_images` ORDER BY DESC'; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}


?>