<?php
//session_start();
//require_once __DIR__ . '/../src/libs/variables.php';

//Ending a php session after 30 minutes of inactivity
$minutesBeforeSessionExpire=86400;
if (isset($_SESSION['last_loggedin']) && (time() - $_SESSION['last_loggedin'] > ($minutesBeforeSessionExpire*30))) {
    session_unset();     // unset $_SESSION   
    session_destroy();   // destroy session data  
}
$_SESSION['last_loggedin'] = time(); // update last activity

function logout(): void {
    if(isUserLogedIn()) {
        unset($_SESSION['username']);
        session_destroy();
        redirect_to("login.php");
    }
}

function requireLogIn(): void {
    if(!isUserLogedIn()) {
        redirect_to("login.php");
    }
}

function redirectIfUserLogedIn() {
    if(isUserLogedIn()) {
        redirect_to("index.php");
    }
}

function currentUser(): string {
    if(isUserLogedIn()) {
        return $_SESSION['username'];
    } else {
        return null;
    }
}

function isUserLogedIn(): bool {
    if(isset($_SESSION['username'])) {
        return true;
    } else {
        return false;
    }
}

function isCurrentLogedInAsAdmin(): bool {
    if(isUserLogedIn() && isset($_SESSION['level'])) {
        if($_SESSION['level'] == 1) {
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }
}


// function isCurrentLogedInAsAdmin() {
//     global $pdo;
//     $sql = "SELECT COUNT(*) FROM `tb_users` WHERE username = :username AND level = 1"; 
//     $stmt = $pdo->prepare($sql);
//     $stmt->bindValue(':username', currentUser());
//     $stmt->execute();
//     $row = $stmt->fetchColumn();
//     $stmt->closeCursor();
//     return $row ? true : false;
// }

// function isCurrentLogedInNotAdmin() {
//     global $pdo;
//     $sql = "SELECT COUNT(*) FROM `tb_users` WHERE username = :username AND level != 1"; 
//     $stmt = $pdo->prepare($sql);
//     $stmt->bindValue(':username', currentUser());
//     $stmt->execute();
//     $row = $stmt->fetchColumn();
//     $stmt->closeCursor();
//     return $row ? true : false;
// }

?>