<?php
session_start();
include_once('../config.php');
$pdo = require_once  SERVERDIR .'/database.php';
require_once SERVERDIR .'/auth.php';
require_once LIBSDIR .'/variables.php';

if(isPostRequest() && isUserLogedIn()) {
    if(isset($_REQUEST['query'])) {
        switch($_REQUEST['query']) {
            case 'statistics':
                getStatistics();
                break;
        }
    } 
}

function getStatistics() {
    $html = '';

    $columnDiv = '<div class="col-lg-4 col-md-4 col-s-4 col-xs-4">';
    $endDiv = '</div>';

    
    // Wallpapers count
    $html .= $columnDiv . '<a href="manage_wallpapers.php">';
    $html .= '<div class="rad-info-box color_3 widget-content widget-content-area br-6">';
    $html .= '<i class="fa fa-image"></i>';
    $html .= '<span class="heading">wallpapers</span>';
    $html .= '<span class="value">' . thousandsCurrencyFormat(wallpapersNumOfRows()) .'</span>';
    $html .=  $endDiv.'</a>'.$endDiv;

    // Wallpapers views

    $html .= $columnDiv . '<div class="rad-info-box color_4 widget-content widget-content-area br-6">';
    $html .= '<i class="fa fa-eye"></i>';
    $html .= '<span class="heading">views</span>';
    $html .= '<span class="value">' . thousandsCurrencyFormat(wallpapersViews()) .'</span>';
    $html .=  $endDiv.''.$endDiv;

    // Wallpapers downloads
    $html .= $columnDiv .'<div class="rad-info-box color_5 widget-content widget-content-area br-6">';
    $html .= '<i class="fa fa-download"></i>';
    $html .= '<span class="heading">downloads</span>';
    $html .= '<span class="value">' . thousandsCurrencyFormat(wallpapersDownloads()) .'</span>';
    $html .=  $endDiv.''.$endDiv;

    // Users count
    $html .= $columnDiv . '<a href="manage_users.php">';
    $html .= '<div class="rad-info-box color_6 widget-content widget-content-area br-6">';
    $html .= '<i class="fa fa-users"></i>';
    $html .= '<span class="heading">Users</span>';
    $html .= '<span class="value">' . thousandsCurrencyFormat(usersNumOfRows()) .'</span>';
    $html .=  $endDiv.'</a>'.$endDiv;

    // User admin
    $html .= $columnDiv . '<a href="manage_admin.php">';
    $html .= '<div class="rad-info-box color_7 widget-content widget-content-area br-6">';
    $html .= '<i class="fa fa-user"></i>';
    $html .= '<span class="heading">Admin</span>';
    $html .= '<span class="value">' .thousandsCurrencyFormat(adminNumOfRows()).'</span>';
    $html .=  $endDiv.'</a>'.$endDiv;

    print $html;
}

function wallpapersNumOfRows() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_images`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
}

function wallpapersViews() {
    global $wallpapersViews;
    foreach(getAllWallpapers() as $wallpaper) {
        $wallpapersViews += $wallpaper['views'];
    }
    return $wallpapersViews;
}

function wallpapersDownloads() {
    global $wallpapersDownloads;
    foreach(getAllWallpapers() as $wallpaper) {
        $wallpapersDownloads += $wallpaper['downloads'];
    }
    return $wallpapersDownloads;
}

function usersNumOfRows() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_users` WHERE level = 0'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
} 

function adminNumOfRows() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_users` WHERE level = 1'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
}

function getAllWallpapers() {
    global $pdo;
    $sql = 'SELECT * FROM `tb_images`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $fetchAllWallpapers = $statment->fetchAll(PDO::FETCH_ASSOC);
    $statment->closeCursor();
    return $fetchAllWallpapers;
}

?>