<?php
//header("Content-Type: application/json; charset=UTF-8");

session_start();
include_once('../config.php');
$pdo = require_once  SERVERDIR .'/database.php';
require_once LIBSDIR .'/variables.php';
require_once SERVERDIR .'/auth.php';

const MESSAGES = [
    'NO_ADMIN' => 'You need admin permission to access this action.',
    'DELETE_SUCCESS' => '$USR deleted successfully.',
    'DELETE_FAILED' => '$USR not exists.',
    'UPDATE_SUCCESS' => 'Updated successfully',
    'UPDATE_FAILED' => 'Update fail.'
];

if(isPostRequest() && isUserLogedIn()) {
  if(isset($_REQUEST['query'])) {
    // Users
    switch($_REQUEST['query']) {
        case 'fetchAllUsers':
            if(isset($_REQUEST['level'], $_REQUEST['page'], $_REQUEST['perpage'])) {
                getUsers(string_strip(['request' => 'level']), string_strip(['request' => 'page']), string_strip(['request' => 'perpage']));
            }
            break;
        case 'addNewUser':

            break;
        case 'updateUserById':
            $identifier = string_strip(['request' => 'identifier']);
            $name = string_strip(['request' => 'full_name']);
            $email = string_strip(['request' => 'email']);
            $picture = string_strip(['request' => 'profile']);
            updateUserById();
            break;
        case 'deleteUserById':
            $identifier = string_strip(['request' => 'identifier']);
            deleteUserById();
            break;
    } 
  }
}

if(isGetRequest() ) {
    // User by ID
    if(isset($_GET['query'])) {
        switch($_GET['query']) {
            case 'fetchUserById':
                $identifier = string_strip(['get' => 'identifier']);
                print json_encode(getUserById(), JSON_PRETTY_PRINT);
                break;
        }
    }
}

function switchLevel($level) {
    switch($level) {
        case 'admins':
            return "level = 1";
        case 'users':
            return 'level = 0'; //'(`username` != "'. $_SESSION['username'] .'")';
    }
}

function isCurrentLoggedInNotAdmin($user): bool {
    return isCurrentLogedInAsAdmin() && $user != currentUser();
}

function getUsers($level, $page, $perpage) { 
    global $pdo;

    $contentHtml = '';
    $paginationHtml = '';  
    $start = ($page -1) * $perpage;
    
    $switchLevel = switchLevel($level);
    $rowCount = numRows($switchLevel);

    $sql = "SELECT * FROM `tb_users` WHERE $switchLevel ORDER BY `id` DESC"; 
    $query = $sql . " LIMIT " .$start. "," .$perpage. "";
    $stmt = $pdo->prepare($query);
    //$stmt->bindValue(':username', $_SESSION['username'], PDO::PARAM_STR);
    $stmt->execute();
    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    
    // Records
    if($rowCount) {
        // Content
        foreach($rows as $user) {
            $editIfUserAsAdmin = isCurrentLogedInAsAdmin() ? 'data-id="' . $user['identifier'] . '" data-toggle="modal" data-target="#edit-user-modal" id="edit-user-modal"' : 'class="d-inline-block" tabindex="0" data-toggle="tooltip" title="You need admin permission to access this action"';
            $deleteIfUserAsAdmin = isCurrentLogedInAsAdmin() ? 'data-id="' . $user['identifier'] . '" data-toggle="modal" data-target="#delete-user-modal" id="delete-user-modal"' : 'class="d-inline-block" tabindex="0" data-toggle="tooltip" title="You need admin permission to access this action"';
            
            $disable = isCurrentLoggedInNotAdmin($user['username']) ? '' : 'disabled';
            //$disable = isCurrentLogedInAsAdmin() ? '' : 'disabled';
            $disablePointer = isCurrentLogedInAsAdmin() ? '' : 'pointer-events: none;';

            $level = $user['level'] == 1 ? 'Admin' : 'Editor';
            $profile = filter_var($user['picture'], FILTER_VALIDATE_URL) ? $user['picture'] : 'assets/img/' .$user['picture']. ' ';

            $contentHtml .= '<tr id="row_'.$user['identifier'].'">';
            //$contentHtml .= '<td><td>';
            $contentHtml .= '<td style="word-break: break-all;" class="text-center"><input id="" type="checkbox"></td>';
            $contentHtml .= '<td>';
            $contentHtml .= '<img alt="avatar" src="'.$profile.'" class="rounded-circle  bs-tooltip" style="height: 65px;width: 65px; border: 1px solid #dadce0;" data-toggle="tooltip" title="' .$user['username']. ' " />';
            $contentHtml .= '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $user['name'] . '</td>';
           
            //$contentHtml .= '<td style="word-break: break-all;">' . $user['username'] . '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $user['email'] . '</td>';
            $contentHtml .= '<td style="word-break: break-all;">' . $user['created_at'] . '</td>';
            $contentHtml .= '<td>';
            $contentHtml .= '<div class="text-center">';
            $contentHtml .= '<h6>' .$level. '</h6>';
            
            $contentHtml .= '</div>';
            $contentHtml .= '</td>';
            $contentHtml .= '<td class="text-center">';
           
            $contentHtml .= '<span '.$editIfUserAsAdmin.'>';
            $contentHtml .= '<a href="javascript:void(0)" class="btn btn-primary btn_edit bs-tooltip '.$disable.'" data-toggle="tooltip" data-placement="top" title="Edit" style="padding: 5px 10px !important;'.$disablePointer.'" >';
            $contentHtml .= '<i class="fa fa-edit"></i>';
            $contentHtml .= '</a>';
            $contentHtml .= '</span>';
        
            $contentHtml .= '<span '.$deleteIfUserAsAdmin.'>';
            $contentHtml .= '<a href="javascript:void(0)" class="btn btn-dark btn_delete bs-tooltip '.$disable.'" data-toggle="tooltip" data-placement="top" title="Delete" style="padding: 5px 10px !important;'.$disablePointer.'">';
            $contentHtml .= '<i class="fa fa-trash"></i>';
            $contentHtml .= '</a>';
            $contentHtml .= '</span>';
            $contentHtml .= '</td>';
            $contentHtml .= '</tr>';
        }
         // Pagination
         $paginationHtml .= pagination($rowCount, $page, $perpage);
    } else {
       $contentHtml .= noUsers();
    }

    //$contentHtml .= $switchLevel."";
    print json_encode(array('content' => $contentHtml, 'pagination' => $paginationHtml), JSON_PRETTY_PRINT);
}

function pagination($rowCount, $page, $perpage) {
    global $paginationHtml;

    if($rowCount > $perpage) {
        $pages = ceil($rowCount / $perpage);
    
        $next = $page;
    
        $paginationHtml .= '<div class="col-md-12 col-xs-12">';
        $paginationHtml .= '<div class="paginating-container pagination-default">';
        $paginationHtml .= '<ul class="pagination">';
    
        $previous = $page - 1;
    
        $paginationHtml .= '<script>console.log("Pages: ' .$pages. ' ")</script>';
        $paginationHtml .+ '****************************************************';
        $paginationHtml .= '<script>console.log("Current Page: ' .$page. ' ")</script>';
    
        $paginationHtml .= '<script>console.log("Previous Page: ' .$previous. ' ")</script>';
    
        if($previous !== 0) {
            $paginationHtml .= '<li class="pag-link first" id="1"><a>First</a></li>';
            $paginationHtml .= '<li class="pag-link prev" id='.$previous.'><a>Prev</a></li>';
        } else {
            $paginationHtml .= '<li class="first" aria-disabled="true"><a>First</a></li>';
            $paginationHtml .= '<li class="prev"><a aria-disabled="true">Prev</a></li>';
        } 
    
        for($i = 1; $i <= $pages; $i++) {
            if($i == $page) {
                $paginationHtml .= '<li class="pag-link active" id='.$i.'><a>'.$i.'</a></li>';
            } else {
                $paginationHtml .= '<li class="pag-link" id='.$i.'><a>'.$i.'</a></li>';
            }
        }
        if($page < $pages) {
            $paginationHtml .= '<li class="pag-link next" id='.($next += 1).'><a>Next</a></li>';
            $paginationHtml .= '<li class="pag-link last" id='.$pages.'><a>Last</a></li>';
        } else {
            $paginationHtml .= '<li class="next" aria-disabled="true"><a>Next</a></li>';
            $paginationHtml .= '<li class="last"><a aria-disabled="true">Last</a></li>';
        }
        $paginationHtml .= '</ul>';
        $paginationHtml .= '</div>';
        $paginationHtml .= '</div>';
     }
     return $paginationHtml;
}

function noUsers() {
    global $contentHtml;

    $contentHtml .= '<div class="container">';
    $contentHtml .= '<div class="text-center">';
    $contentHtml .= '<img src="assets/img/noun-emotion.svg" at="No Photo" style="width: 100px;height:100px;"></img>';
    $contentHtml .= '<p>No user found!</p>';
    $contentHtml .= '</div>';
    $contentHtml .= '</div>';

    return $contentHtml;
}

function checkUserExists(): bool {
    global $pdo, $identifier;
    $sql = 'SELECT identifier FROM `tb_users` WHERE (identifier = :uniqueId)'; 
    $stmt = $pdo->prepare($sql);
    $stmt->bindValue(':uniqueId', $identifier, PDO::PARAM_INT); 
    $stmt->execute();
    $numRow = $stmt->fetchColumn();
    return $numRow > 1 ? true : false;
}

function getAllUsers() {
    global $pdo;
    $sql = 'SELECT name, username, email, picture, identifier FROM `tb_users`'; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function getUserById() {
    global $pdo, $identifier;
    $sql = "SELECT name, email, picture, identifier FROM `tb_users` WHERE identifier =  $identifier "; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function getUserByUsername() {
    global $pdo, $username;
    $sql = "SELECT name, email, picture, identifier FROM `tb_users` WHERE username =  $username "; 
    $stmt = $pdo->prepare($sql);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    $stmt->closeCursor();
    return $row;
}

function updateUserById() {
    global $pdo, $identifier, $name, $email, $picture, $isAdmin, $msg;

    if(isCurrentLogedInAsAdmin()) {
        if(checkUserExists()) {
            $sql = "UPDATE `tb_users` SET name = :name, email = :email, picture = :picture, created_at = now() WHERE identifier = " . $identifier . "";
            $stmt = $pdo->prepare($sql);
            $stmt->bindValue(':name', $name, PDO::PARAM_STR);
            $stmt->bindValue(':email', $email, PDO::PARAM_STR);
            $stmt->bindValue(':picture', $picture, PDO::PARAM_STR);
            $updateSet = $stmt->execute() ? true : false;
            $msg = str_replace('$USR', 'User', MESSAGES['UPDATE_SUCCESS']);
        } else {
            $updateSet = false;
            $msg = str_replace('$USR', 'User', MESSAGES['UPDATE_FAILED']) . ' '. $_SESSION['username'];
        }
        $isAdmin = true;
    } else {
        $isAdmin = false;
        $updateSet = false;
        $msg = MESSAGES['NO_ADMIN'];
    }
    print json_encode(array('admin' => $isAdmin, 'success' => $updateSet, 'msg' => $msg), JSON_PRETTY_PRINT);
}

function deleteUserById() {
    global $pdo, $identifier, $isAdmin, $msg;

    if(isCurrentLogedInAsAdmin()) {
        if(checkUserExists()) {
            $sql = "DELETE FROM `tb_users` WHERE identifier = " . $identifier . "";
            $stmt = $pdo->prepare($sql);
            $deleteSet = $stmt->execute() ? true : false;
            $msg = str_replace('$USR', 'User', MESSAGES['DELETE_SUCCESS']);
        } else {
            $deleteSet = false;
            $msg = str_replace('$USR', 'User', MESSAGES['DELETE_FAILED']);
        }
        $isAdmin = true;
    } else {
        $isAdmin = false;
        $deleteSet = false;
        $msg = MESSAGES['NO_ADMIN'];
    }
    print json_encode(array('admin' => $isAdmin, 'success' => $deleteSet, 'msg' => $msg), JSON_PRETTY_PRINT);
}

function usersCount() {
    global $pdo;
    $sql = 'SELECT COUNT(*) FROM `tb_users`'; 
    $statment = $pdo->prepare($sql);
    $statment->execute();
    $rowCount = $statment->fetchColumn();
    $statment->closeCursor();
    return $rowCount;
}

function numRows($condition) {
    global $pdo;
    $sql = "SELECT COUNT(*) FROM `tb_users` WHERE $condition ";
    $stmt = $pdo->prepare($sql);
    //$stmt->bindValue(':username', $_SESSION['username'], PDO::PARAM_STR);
    $stmt->execute();
    return $stmt->fetchColumn();
}

?>